/***************************************************************************/
/* 			     		    	                           */
/*  Image Class Library       		                                   */
/* 			     		    	                           */
/*  Image data structure and simple manipulations i.e. I/O, convolution    */
/* 			     		    	                           */
/***************************************************************************/
/* 			     		    	                           */
/*  Last modified by    		    	                           */
/*                   Binnur KURT            	                           */
/*  When        	     		    	                           */
/* 		     August 19th 1999    	                           */
/* 			     		    	                           */
/***************************************************************************/
#include <string.h>
#include <iostream.h>

#ifndef __IMAGE__
#define __IMAGE__

typedef struct FilterStruct{
        int   Width, Height   		;
        int   xx,yy			;
        float Gain		        ;
        float **coeff       		;
} Filter                 ;

class Image{
      public:
       Image();
       ~Image();
       int  Width,Height;
       int  Row,Column;
       void AssignName(char *);
       void LoadFromTImage(TImage *);
       void SaveToTImage(TImage *);
       void PasteImageFromAnotherImage(Image&);
       void Invert();
       inline bool  ValidPixel(int,int);
       void PrintName();
       void freeAll();
       inline void SetFilterLength(int,int);
       inline void SetFilterOrigin(int,int);
       void Convolve();
       unsigned char **Y;
       float **filterOutput;
       Filter filter;
       bool IsNewImageLoaded;
       bool IsMemoryAllocatedForY;
       bool IsMemoryAllocatedForFilter;
      private:
       char *filename;
       unsigned int length;
} ;
#endif


