#include "hipsio.c"
#include "chain.h"
#include <stdio.h>

Endpoint  *HeaderOfChain 				 ;
Endpoint  *TailOfChain  				 ;
int       NumberOfCode = 0 	                         ;

int           IsEndPoint(Coordinate ,HipsImage)                                ;
int           B(Coordinate ,HipsImage)                                         ;
void          FindEndPoints(HipsImage )		                               ;
void          DeleteEndPoint(Coordinate )			               ;
void          AddEndPoint(Coordinate )				               ;
void          AddChain(Endpoint *,Coordinate ,Direction )	               ;
int           IsVerifiedEndPoint(Coordinate )			               ;
void          FindEdgeSegments(HipsImage )		                       ;
Coordinate    GetNextPoint(Coordinate ,Direction ,HipsImage )                  ;
Direction     GetDirection(Coordinate ,Coordinate ) 	   		       ;
Direction     GetNormalDirection(Direction )				       ;
Direction     RotateDirection(Direction ,Angle )			       ;
void          CutSegment(Coordinate ,Coordinate ,HipsImage )		       ;
void          FreeEndPointStructure(void)				       ;
int           GetNumberOfEndPoints(void)				       ;
void          DeleteChain(ChainCode *,HipsImage)    			       ;
void          ThresholdEdgeInformation(HipsImage)			       ;
void          FindDirectionRotations(void)				       ;
void          FindCodeWords(void)					       ;
int           CheckCoordinate(Coordinate ,int ,int )			       ;
int	      GetNumberOfEdgePoints(HipsImage )				       ;
Coordinate    GetFirstEdgePoint(HipsImage )				       ;
void          GetRowsAndCols(void)									;
int           WhichDirection(Direction ,int )								;
int           GetSegmentLength(ChainCode *)								;
void          PrintSegmentLength(Endpoint *,char *)	       					;
void          SetImageToConstant(HipsImage ,unsigned char )			;
void          DeleteIsolatedEdgePoints(Endpoint *,HipsImage )			      		;
void          RemoveShortEdgeSegments(Endpoint *ptr,HipsImage img,int len)     				;
void          SaveSegmentToFile(Endpoint *p,HipsImage img,char *FileName)      				;
void          Enlarge(HipsImage img,HipsImage eimg)			       ;
void	      DrawBorder(HipsImage img,int edgevalue)		               ;
void          ConvertEDGE2EDGE_255(HipsImage img)			       ;
int           power(int ,int )						       ;
int           Max(int ,int )						       ;
int           Min(int ,int )						       ;
/* Ordering of Edge Segments According 2 their properties given in chain.h	       		       */
void          SetProperties(Endpoint *,HipsImage )		       ;
float         GetSegmentMeanContrast(ChainCode *,HipsImage )	       ;
float         GetSegmentMeanCurvature(ChainCode *ptr)			       ;
float         GetSegmentStandardDeviation(ChainCode *ptr,float Mean,HipsImage img)			;
float         GetSegmentMeanGrayLevel(ChainCode *ptr,HipsImage img)	       ;
void          SetPriority(PropertyWeight pw,Endpoint *ptr)		       ;
void 	      SetIndex(Endpoint *ptr)					       ;
int           WhichIndex(Endpoint *ptr,float pr,int index)	       	       ;
void          ThresholdEdgeSegmentsAccordingToTheirPriority(Endpoint *,int,HipsImage);
int           GetMaxIndex(Endpoint *ptr)				       ;
int           LEX(Endpoint *ptr,int,int)					       ;

int LEX(Endpoint *ptr,int rows,int cols)
{
     Endpoint  *p,*q											;
     ChainCode *r											;
     int i,max												;
     Properties pro											;
     Coordinate c											;
	
     p = ptr												;
     if(ptr!=NULL)
       do
         {
          p->property.MeanCurvature = (float) cols * (float) p->point.x + (float) p->point.y		;
          p = p->next											;
         }
       while(p!=NULL);
     p = ptr												;
     if(ptr!=NULL)
       do
         {
          q = ptr											;
          p->property.Length = 1									;
          do {
             if(p->property.MeanCurvature > q->property.MeanCurvature) p->property.Length ++		;
             q = q->next										;
            }
          while(q!=NULL) 										;
          p = p->next											;
         }
       while(p!=NULL);
     i = 1												;
     p = ptr												;
     if(ptr!=NULL)
       do
         {
          q = ptr											;
          do{
             if(i != q->property.Length ) 
               q = q->next										;
            } 
          while( (q!=NULL) && ( i != q->property.Length))						;
         if(q!=NULL) {
         c = p->point											;
         p->point = q->point										;
         q->point = c											;
         r = p->chain											;
         p->chain = q->chain										;
         q->chain = r											;
         pro = p->property										;
         p->property = q->property									;
         q->property = pro										; }
         p = p->next											;
         i++												;
        }
       while(p!=NULL);
    
     max = 0												;
     p = ptr												;
     if(ptr!=NULL)
       do
         {
          i = (int) ( (p->next)->property.MeanCurvature - p->property.MeanCurvature ) 			;
          if(i>max) max = i										;
          if(i<0) { printf("\n Error ! \n"); exit(0) ; }
          p = p->next											;
         }
       while((p->next)!=NULL);
     return(max)		;
}

int GetMaxIndex(Endpoint *ptr)
{   Endpoint *p											       	;
    int m = 0												;
     p = ptr 												;
     if(ptr!=NULL)
       do
         {
          if(p->property.index>m) m = p->property.index							;
          p = p->next											;
         }
       while(p!=NULL);
     return(m)	;
}

void ThresholdEdgeSegmentsAccordingToTheirPriority(Endpoint *ptr,int index,HipsImage img)
{
     Endpoint *p,*q,*r	;
     int i=0    ;
     p = ptr 		;
     index = (int) ( ( (float) GetMaxIndex(ptr) * (float) index ) / 100.0 )    ;
     while(p!=NULL){
         r = p->next                                                           ;
         printf("%d",i)                                                        ;
         if(p->property.index > index){
            DeleteChain(p->chain,img)					       ;
            q = p							       ;
            img.UCHARMap[p->point.x][p->point.y] = _NON_EDGE		       ;
             if(q==ptr){
                HeaderOfChain = q->next 				;
                if((q->next) !=NULL)
                  (q->next)->before = NULL 				       ;
                free(q)							       ;
               } /* if */
             else{
                if((q->next) == NULL ){
                   TailOfChain = q->before				;
                   if( (q->before) != NULL )
                     (q->before)->next = NULL				;
                   free(q)						;
                  } /*else if*/
                 else{
                   if(q->before!=NULL)
                    (q->before)->next = q->next                          ;
                   if(q->next !=NULL)
                    (q->next)->before = q->before                        ;
                   free(q)						       ;
                 } /* else */
               } /* else */
             }/* if */
           p = r                                                               ;
           i++                                                                 ;
         } /* while */
}

void SetIndex(Endpoint *ptr)
{
     Endpoint  *p	;
    
     p = ptr ;
     if(ptr!=NULL)
       do
         {
          p->property.index = WhichIndex(ptr,p->property.priority,p->property.index)	;
          p = p->next									;
         }
       while(p!=NULL);
}

int WhichIndex(Endpoint *ptr,float pr,int index)
{
     Endpoint  *p	;
     int       i = 0    ;
 
     p = ptr ;
     if(ptr!=NULL)
       do
         {
          if(pr>p->property.priority) i++;
	    else
          if(pr == p->property.priority)
            if( p->property.index != 0) i++ ; 
          p = p->next	;
         }
       while(p!=NULL);
     return(i) ;
}

void SetPriority(PropertyWeight pw,Endpoint *ptr)
{
     Endpoint  *p										;

     p = ptr 											;
     if(ptr!=NULL)
       do
         {
          p->property.index    = 0								;
          p->property.priority = pw.CurvatureWeight         * p->property.MeanCurvature     +
				 pw.StandardDeviationWeight * p->property.StandardDeviation +
				 pw.LengthWeight            * (float) p->property.Length    +
                                 pw.MeanGrayLevelWeight     * p->property.MeanGrayLevel     +
                		 pw.ContrastWeight          * p->property.MeanContrast      	;
          p = p->next										;       
         }
       while(p!=NULL);
}

void SetProperties(Endpoint *ptr,HipsImage img)
{
     Endpoint  *p	;
     ChainCode *r,*s	;

     p = ptr ;
     if(ptr!=NULL)
       do
         {
	  r = p->chain 											;
          p->property.Length            = GetSegmentLength(r)						;
	  p->property.MeanGrayLevel     = GetSegmentMeanGrayLevel(r,img)				;
          p->property.StandardDeviation = GetSegmentStandardDeviation(r,p->property.MeanGrayLevel,img)	;
          p->property.MeanCurvature     = GetSegmentMeanCurvature(r)   					;
          p->property.MeanContrast      = GetSegmentMeanContrast(r,img)	     		      	        ;
	  p = p->next											;
         }
       while(p!=NULL);
}

float GetSegmentMeanContrast(ChainCode *ptr,HipsImage img)
{
      float contrast = 0.0									;
      ChainCode *q										;
      int   Length = 0,dx,dy									;
      Direction  tangent,normal,pnormal,previous            					;
      Coordinate r,s,t										;
      float      grt,Dif_right,Dif_left,AvgRightContrast,AvgLeftContrast			;
      float      l,w_right,w_left								;
      int    Current,Change,InsideDomain							;

      q = ptr	;
      AvgRightContrast = AvgLeftContrast = 0.0							;
      previous = q->dir										;
      if(q!=NULL)
	do
          {
           Length ++ 										;
           previous = q->dir									;
	   tangent  = q->dir 									;
	   if((tangent%2)==1) {
	      if(((tangent==3) || (tangent == 7) ) && ((previous== 2)||(previous==6)||(previous==1)||(previous==5)))
		normal = GetNormalDirection((tangent-1)%8)					;
	      else
	      if(((tangent == 1) || (tangent == 5) ) && ((previous== 0)||(previous==4)||(previous==1)||(previous==3)))
		normal = GetNormalDirection((tangent-1)%8)					;
	      else
		normal = GetNormalDirection((tangent+1)%8)					; }
	      else
		normal = GetNormalDirection(tangent)			       			;
	     previous = tangent									;
		pnormal = RotateDirection(normal,_ANGLE_180)					;
		/* Normal Direction					       			*/
		l = 0.0										;
		t = q->point									;
		dx  = unit_direction[normal][0]							;
		dy  = unit_direction[normal][1]							;
		s.x = t.x + dx									;
		s.y = t.y + dy					       	;
		InsideDomain = CheckCoordinate(s,img.Row,img.Column)	       ;
		if( InsideDomain == _TRUE)
		  {
		   grt = (float)img.UCHARMap[s.x][s.y] - (float)img.UCHARMap[t.x][t.y]   				;
		   if(grt<0.0) {
		      grt = 0.0 - grt								;
		      Change = _FALSE								; }
		   else Change = _TRUE								;
		      t   = s						       			;
		      l  += 1.0									;
		  }

		do
		  {
		   dx  = unit_direction[normal][0]						;
		   dy  = unit_direction[normal][1]						;
		   s.x = t.x + dx								;
		   s.y = t.y + dy					       			;
		   InsideDomain = CheckCoordinate(s,img.Row,img.Column)				;
		   if( InsideDomain == _TRUE)
		     {
		      grt = (float)img.UCHARMap[s.x][s.y] - (float)img.UCHARMap[t.x][t.y]   	;
		      if(grt<0.0) {
			grt = 0.0 - grt								;
			Current = _FALSE 							; }
		      else Current = _TRUE							;
		      if( Current == Change ) {
			t  = s								       	;
			l += 1.0								;
		       }
		    }
		  }
		while((grt>=1.0)&&(l<8.0)&&(InsideDomain == _TRUE)&&(Current == Change))	;
		Dif_right = (float) img.UCHARMap[t.x][t.y] - (float) img.UCHARMap[q->point.x][q->point.y]		;
                if(Dif_right<0.0) Dif_right = 0.0 - Dif_right				;
		AvgRightContrast += Dif_right						;
		/*******************************************************************************/
		/* Other normal direction 					       	       */
		/*******************************************************************************/
		l = 0.0										;
		t = q->point									;

		dx  = unit_direction[pnormal][0]						;
		dy  = unit_direction[pnormal][1]						;
		s.x = t.x + dx									;
		s.y = t.y + dy					       				;
		InsideDomain = CheckCoordinate(s,img.Row,img.Column)				;	
		if( InsideDomain == _TRUE)
		  {
		   grt = (float)img.UCHARMap[s.x][s.y] - (float)img.UCHARMap[t.x][t.y]   				;
		   if(grt<0.0) {
		      grt = 0.0 - grt								;
		      Change = _FALSE								;}
		   else Change = _TRUE								;
		      t   = s						       			;
		      l  += 1.0									;
		     }

		do
		 {
		  dx  = unit_direction[pnormal][0]						;
		  dy  = unit_direction[pnormal][1]						;
		  s.x = t.x + dx								;
		  s.y = t.y + dy					       			;
		  InsideDomain = CheckCoordinate(s,img.Row,img.Column)				;
		  if( InsideDomain == _TRUE)
		    {
		     grt = (float)img.UCHARMap[s.x][s.y] - (float)img.UCHARMap[t.x][t.y]  	 		;
		     if(grt<0.0) {
		       grt = 0.0 - grt								;
		       Current = _FALSE 							; }
		     else Current = _TRUE							;
		     if(Current == Change){		
		       t = s							       		;
		       l+= 1.0									;
		      }
		    }
		 }
	       while((grt>=1.0)&&(l<8.0)&&(InsideDomain == _TRUE)&&(Current==Change))	;
	       Dif_left = (float) img.UCHARMap[t.x][t.y] - (float) img.UCHARMap[q->point.x][q->point.y]			;
               if(Dif_left<0.0) Dif_left = 0.0 - Dif_left				;
               AvgLeftContrast += Dif_left						;
               q = q->next								;
          }
        while(q!=NULL);
      /*
      contrast = ( 0.5 * (AvgLeftContrast + AvgRightContrast ) ) / (float) Length 	;
      */
      contrast = ( 0.5 * (AvgLeftContrast + AvgRightContrast ) ) 		 	;
	
      return(contrast);
}

float GetSegmentMeanCurvature(ChainCode *ptr)
{
      float cur = 0.0	 	;
      ChainCode  *q		;
      int   Length=1		;

      q = ptr			;
      if(q!=NULL) q = q->next	;
      if(q!=NULL)
        do
          {
           Length ++ 						;
           cur   += abs(q->dir)					;
           q      = q->next					;
          }
        while(q!=NULL);
      /*cur /= (float) Length ;*/
      return(cur)	    ;
}

float GetSegmentMeanGrayLevel(ChainCode *ptr,HipsImage img)
{
      float mean = -1.0 ;
      ChainCode  *q	;
      int   Length=1	;

      q = ptr	;
      if(q!=NULL)
        do
          {
           Length ++ 						;
           mean   += (float) img.UCHARMap[q->point.x][q->point.y] 	;
           q       = q->next					;
          }
        while(q!=NULL);
      mean /= (float) Length ;
      return(mean);
}


float GetSegmentStandardDeviation(ChainCode *ptr,float Mean,HipsImage img)
{
      float s = 1.0, N  ;
      ChainCode  *q	;
      int   Length=1	;

      q = ptr	;
      if(q!=NULL)
        do
          {
           Length ++ 						;
           N       = (float) img.UCHARMap[q->point.x][q->point.y] - Mean	;
           s      += N * N					;
           q       = q->next					;
          }
        while(q!=NULL);
      s /= (float) Length ;
      s  = sqrt(s)	  ;
      return(s)		  ;
}

void ConvertEDGE2EDGE_255(HipsImage img)
{
     int i,j	;

     for(i=0;i<img.Row;i++)
        for(j=0;j<img.Column;j++)
           if(img.UCHARMap[i][j]==_EDGE) img.UCHARMap[i][j] = _EDGE_255 ;
}
			
int CheckCoordinate(Coordinate p,int rw,int cl)
{
   if( (p.x>=0) && (p.x<rw) && (p.y>=0) && (p.y<cl) )
     return(_TRUE);
   else
     return(_FALSE);  
}

Direction GetNormalDirection(Direction tng)
{
  return( ( tng + 2 ) % 8 );
}

Direction RotateDirection(Direction d,Angle ang) 
{
  return( ( d + ang) % 8 ) ;
}

int Max(int m1,int m2)
{
    if(m1>=m2)
      return(m1);
    else
      return(m2);
}

int Min(int m1,int m2)
{
    if(m1>=m2) 
      return(m2);
    else
      return(m1);
}

void DrawBorder(HipsImage img,int edgevalue)
{
     int i ;

     for(i=0;i<img.Row;i++)
	{
	 img.UCHARMap[i][0]      = edgevalue ;
	 img.UCHARMap[i][img.Column-1] = edgevalue ;
	}

     for(i=0;i<img.Column;i++)
	{
	 img.UCHARMap[0][i]      = edgevalue ;
	 img.UCHARMap[img.Row-1][i] = edgevalue ;
	}
}

void RemoveShortEdgeSegments(Endpoint *ptr,HipsImage img,int len)
{
     Endpoint  *p,*r 	;
     ChainCode *q 	;
     Coordinate c	;
     int       length	;

     p = ptr ;
     if(p!=NULL)
       do
         {
	  q = p->chain ;
          if(q!=NULL)
          length = GetSegmentLength(q)	;
          else
          length = 0			;
          if(length<len)
            {
             img.UCHARMap[p->point.x][p->point.y] = _NON_EDGE	;
             if(q!=NULL)
			DeleteChain(q,img)				;
             r = p->before      			;
             if(r!=NULL)
               r->next = p->next 			;
	     if(p->next!=NULL)
               ((p->next)->before) = r			;
             r = p 	 				;
             p = p->next 				;
             if(r==ptr) ptr = p->next			;
             free(r) 	 				;
            }
          else
  	    p = p->next ;
         }
       while(p!=NULL);
}

void DeleteChain(ChainCode *ptr,HipsImage img)
{
     ChainCode *r,*s ;

     r = ptr ;
     if(r!=NULL)
       do
	 {
          img.UCHARMap[r->point.x][r->point.y] = _NON_EDGE	;
	  s = r->next					;
          free(r)					;
          r = s						;		 
         }
       while(r!=NULL);
}

void SaveSegmentToFile(Endpoint *p,HipsImage img,char *FileName)
{
     FILE      *hFile 	;
     Endpoint  *q	;
     ChainCode *s	;
  
     hFile = fopen(FileName,"wb+");
     if(hFile==NULL)
       {
	printf("\n Unable to open a file (%s)",FileName);
	printf("\n Be sure that disk has 'rw' permitions\n");
	exit(0);
       }

     q = p ;

     if(q!=NULL)
       do
         {
          fprintf(hFile,"%d %d %d\n",q->point.x,q->point.y,(int)img.UCHARMap[q->point.x][q->point.y]);
          s = q->chain ;
	  if(s!=NULL)
            do
	      {
               fprintf(hFile,"%d %d %d\n",s->point.x,s->point.y,(int)img.UCHARMap[s->point.x][s->point.y])	;
               s = s->next					;
              }
            while(s!=NULL);
          fprintf(hFile,"%d %d %d\n",-1,-1,-1); 
	  q = q->next	;
         }
       while(q!=NULL); 
}

void Enlarge(HipsImage img,HipsImage eimg)
{
     int i,j,k,dx,dy  	;
     Coordinate p,q	;

     SetImageToConstant(eimg,_NON_EDGE);

     for(i=0;i<img.Row;i++)
        for(j=0;j<img.Column;j++)
	   {
            p.x = i ;
            p.y = j ;
            if(img.UCHARMap[i][j] == _EDGE )
              eimg.UCHARMap[i][j] = _EDGE_255 ;
	    if(img.UCHARMap[i][j] == _EDGE)
              for(k=0;k<8;k++)
                  {
 		   dx = unit_direction[k][0] 					;
  		   dy = unit_direction[k][1] 					;
		   q.x = p.x + dx 						;
 		   q.y = p.y + dy						;
                   if( (q.x>=0) && (q.x<img.Row) && (q.y>=0) && (q.y<img.Column) )
                     eimg.UCHARMap[q.x][q.y] = _EDGE_255 	;
                  }
            }
}

void DeleteIsolatedEdgePoints(Endpoint *ptr,HipsImage img)
{    Endpoint *q	;

     if(ptr!=NULL)
       do
         {
	  q = ptr->next	;
	  if(ptr->chain == NULL)
            {
             DeleteEndPoint(ptr->point);
             img.UCHARMap[ptr->point.x][ptr->point.y] = _NON_EDGE ;
            }
          ptr = q	;
         }
       while(ptr!=NULL);
}

void SetImageToConstant(HipsImage img,unsigned char value)
{
     int i,j	;

     for(i=0;i<img.Row;i++)
        for(j=0;j<img.Column;j++)
	   img.UCHARMap[i][j] = value ;
}

Coordinate GetFirstEdgePoint(HipsImage img)
{
  Coordinate p ;
  int i,j      ;

  for(i=0;i<img.Row;i++)
     for(j=0;j<img.Column;j++)
	if(img.UCHARMap[i][j]==1)
	  {
	   p.x = i ;
	   p.y = j ;
	   return(p);
	  }
   return(p);
}

int GetSegmentLength(ChainCode *ptr)
{
    int len=1    ;
    ChainCode *q ;

    if(ptr!=NULL)
    do
      {
       ptr = ptr->next ;
       len ++;
      }
    while(ptr!=NULL);
    return(len);
}

void PrintSegmentLength(Endpoint *ptr,char *FileName)
{
     int  i=1		;
     FILE *hFile	;

     hFile = fopen(FileName,"wb+");
     if(hFile==NULL)
       {
	printf("\n Unable to open a file (%s)",FileName);
	printf("\n Be sure that disk has 'rw' permitions\n");
	exit(0);
       }

     if(ptr!=NULL)
     do
       {
        fprintf(hFile,"\n Segment %d",i);
	fprintf(hFile,"\n Length %d",GetSegmentLength(ptr->chain));
        ptr = ptr->next ;
        i++;
       }
     while(ptr!=NULL);
}

int GetNumberOfEdgePoints(HipsImage img)
{
    int i,j 	;
    int nEdge=0	;

    for(i=0;i<img.Row;i++)
       for(j=0;j<img.Column;j++)
	  if(img.UCHARMap[i][j]==1) nEdge++;
    return(nEdge);
}

int WhichDirection(Direction d,int r)
{
    int i;
    for(i=0;i<8;i++)
       if(rotation[d][i]==r)
	 return(i);
    return(i);
}

void FindDirectionRotations(void)
{
     int i		;
     Endpoint *p	;
     ChainCode *q   	;
     Direction	d,dd  	;

     p = HeaderOfChain ;
     if(p!=NULL)
       do
	 {
	  q = p->chain ;
	  if(q!=NULL)
	    {
	     d = q->dir  ;
	     q = q->next ;
	     if(q!=NULL)
	       do
		 {
		  dd = q->dir 	           ;
		  q->dir = rotation[d][dd] ;
		  d = dd 		   ;
		  q = q->next 		   ;
		 }
	       while(q!=NULL);
	    }
	  p = p->next ;
	 }
       while(p!=NULL);
}

void ThresholdEdgeInformation(HipsImage img)
{
     int i,j	;
     for(i=0;i<img.Row;i++)
	for(j=0;j<img.Column;j++)
           if(img.UCHARMap[i][j]>=_EDGE)
             img.UCHARMap[i][j]=_EDGE ;
           else
             img.UCHARMap[i][j]= 0 ;           
}

int GetNumberOfEndPoints(void)
{
     int nEnd=0		;
     Endpoint *p	;

     p=HeaderOfChain ;
     if(p!=NULL)
       do
	 {
	  p = p->next	;
	  nEnd++	;
	 }
       while(p!=NULL);
     return(nEnd);
}

int B(Coordinate p,HipsImage img)
{
    int b	;

    if( (p.x==0) && (p.y==0) )
      {
       b = img.UCHARMap[p.x][p.y+1] 	+
	   img.UCHARMap[p.x+1][p.y] 	+
	   img.UCHARMap[p.x+1][p.y+1] 	;
      }
    else
    if( (p.x==img.Row-1) && (p.y==0) )
      {
       b = img.UCHARMap[p.x][p.y+1] 	+
	   img.UCHARMap[p.x-1][p.y] 	+
	   img.UCHARMap[p.x-1][p.y+1] 	;
     }
    else
    if( (p.x==0) && (p.y==img.Column-1) )
      {
       b = img.UCHARMap[p.x][p.y-1] 	+
	   img.UCHARMap[p.x+1][p.y] 	+
	   img.UCHARMap[p.x+1][p.y-1] 	;
     }
    else
    if( (p.x==img.Row-1) && (p.y==img.Column-1) )
      {
       b = img.UCHARMap[p.x][p.y-1] 	+
	   img.UCHARMap[p.x-1][p.y] 	+
	   img.UCHARMap[p.x-1][p.y-1] 	;
      }
    else
    if( (p.x>0) && (p.x<img.Row-1) &&(p.y==0) )
      {
       b = img.UCHARMap[p.x][p.y+1] 	+
	   img.UCHARMap[p.x-1][p.y] 	+
	   img.UCHARMap[p.x-1][p.y+1] 	+
	   img.UCHARMap[p.x+1][p.y+1] 	+
	   img.UCHARMap[p.x+1][p.y] 	;
      }
    else
    if( (p.x>0) && (p.x<img.Row-1) && (p.y==img.Column-1) )
      {
       b = img.UCHARMap[p.x][p.y-1] 	+
	   img.UCHARMap[p.x-1][p.y] 	+
	   img.UCHARMap[p.x-1][p.y-1] 	+
	   img.UCHARMap[p.x+1][p.y-1] 	+
	   img.UCHARMap[p.x+1][p.y] 	;
      }
    else
    if( (p.y>0) && (p.y<img.Column-1) &&(p.x==0) )
      {
       b = img.UCHARMap[p.x][p.y-1] 	+
	   img.UCHARMap[p.x][p.y+1] 	+
	   img.UCHARMap[p.x+1][p.y+1] 	+
	   img.UCHARMap[p.x+1][p.y-1] 	+
	   img.UCHARMap[p.x+1][p.y] 	;
      }
    else
    if( (p.y>0) && (p.y<img.Column-1) &&(p.x==img.Row-1) )
      {
       b = img.UCHARMap[p.x][p.y-1] 	+
	   img.UCHARMap[p.x][p.y+1] 	+
	   img.UCHARMap[p.x-1][p.y+1] 	+
	   img.UCHARMap[p.x-1][p.y-1] 	+
	   img.UCHARMap[p.x-1][p.y] 	;
       }
    else
      {
       b = img.UCHARMap[p.x-1][p.y-1] 	+
	   img.UCHARMap[p.x-1][p.y] 	+
	   img.UCHARMap[p.x-1][p.y+1] 	+
	   img.UCHARMap[p.x][p.y-1] 	+
	   img.UCHARMap[p.x][p.y+1] 	+
	   img.UCHARMap[p.x+1][p.y-1] 	+
	   img.UCHARMap[p.x+1][p.y] 	+
	   img.UCHARMap[p.x+1][p.y+1] 	;
       }
    return(b);
}

void FindEndPoints(HipsImage img)
{
     Coordinate c ;
     int i,j      ;

     for(i=0;i<img.Row;i++)
	for(j=0;j<img.Column;j++)
           {
            c.x = i ;
            c.y = j ;
	    if( (img.UCHARMap[c.x][c.y] == _EDGE) && (B(c,img) == 1) )
              AddEndPoint(c);
           }
}

void FreeEndPointStructure(void)
{
     Endpoint	*p,*q	;
     ChainCode  *c,*d	;
     q = HeaderOfChain ;
     if(q!=NULL)
       do
	 {
	  c = q->chain ;
	  if(c!=NULL)
	    {
	     do
	       {
		d = c->next;
		free(c)    ;
		c = d      ;
	       }
	     while(c!=NULL);
	    }

	  p = q->next;
	  free(q)    ;
	  q = p      ;
	 }
       while(p!=NULL);
}

void DeleteEndPoint(Coordinate p)
{
     Endpoint	*q	    ;
     int Found = _FALSE ;

     q = HeaderOfChain ;
     if(q!=NULL)
       do
	 {
	  if( ( (q->point.x) ==p.x ) &&
	      ( (q->point.y) ==p.y ) )
	    {
	     Found = _TRUE ;
	     if(q == HeaderOfChain)
	       {
		(HeaderOfChain->next)->before = NULL ;
		HeaderOfChain = q->next ;
		free(q);
	       }
	     else
	     if(q == TailOfChain)
	       {
		(TailOfChain->before)->next = NULL ;
		TailOfChain = q->before ;
		free(q);
	       }
	     else
	       {
		(q->next)->before = q->before ;
		(q->before)->next = q->next   ;
	       }
	    }
	  q = q->next ;
	 }
       while( (q!=NULL) && (Found==_FALSE) );
}

void AddEndPoint(Coordinate p)
{
     Endpoint	*q; 

     q = (Endpoint *) malloc(sizeof(Endpoint)) ;
     if (HeaderOfChain == NULL )
	{
 	 HeaderOfChain     = q 					;
	 TailOfChain       = q					;
	 q->next   	   = NULL      				;
	 q->before 	   = NULL       			;
	 q->chain  	   = NULL      				;
	 q->tail    	   = NULL      				;
         q->Coeff_Left     = NULL				;
         q->Coeff_Right    = NULL				;
	 q->point      	   = p	       				;
         q->property.index = 0					;
        }
      else
	{
	 q->next           = NULL		       		;
	 q->before         = TailOfChain			;
	 TailOfChain->next = q					;
	 TailOfChain       = q					;
         q->Coeff_Left     = NULL				;
         q->Coeff_Right    = NULL				;
	 q->point	   = p					;
         q->chain          = NULL				;
	 q->tail	   = NULL				;
	 q->property.index = (q->before)->property.index + 1	;
	}
}

void AddChain(Endpoint *ptr,Coordinate p,Direction d)
{
     ChainCode *q;

      q = (ChainCode *) malloc(sizeof(ChainCode)) ;
      if(ptr->chain==NULL)
	{
	 ptr->chain = q 	;
	 q->point   = p 	;
	 q->dir     = d 	;
	 q->next    = NULL 	;
         ptr->tail  = q 	;
	}
      else
	{
	 q->next    = NULL       ;
	 (ptr->tail)->next = q	 ;
	 ptr->tail  = q		 ;
	 q->point   = p		 ;
	 q->dir	    = d		 ;
	}
}

void FindEdgeSegments(HipsImage img)
{
     Coordinate _endpoint	;
     Coordinate segment		;
     Endpoint	*ptr		;
     Direction  d=_NORTH	;

     ptr = HeaderOfChain	;

     if((ptr==NULL) && ( GetNumberOfEdgePoints(img) > 0 ))
       {
	AddEndPoint(GetFirstEdgePoint(img))	;
	ptr = HeaderOfChain			;
       }

     do
	{
	 _endpoint = ptr->point	;
	 img.UCHARMap[_endpoint.x][_endpoint.y] = _NON_EDGE ;
         if(B(_endpoint,img)>0)
	 do
	   {
	    segment = GetNextPoint(_endpoint,d,img);
	    img.UCHARMap[segment.x][segment.y] = _NON_EDGE ;
	    d = GetDirection(_endpoint,segment);
	    AddChain(ptr,segment,d);
	    _endpoint = segment ;
	   }
	 while( (B(segment,img)!=0) && (segment.x>=0) && (segment.y>=0) );
	 if(IsVerifiedEndPoint(segment) == _TRUE)
	   DeleteEndPoint(segment);
	 if((ptr->next == NULL) && ( GetNumberOfEdgePoints(img) > 0 ))
	    AddEndPoint(GetFirstEdgePoint(img));
	 ptr = ptr->next	;
	}
     while(ptr!=NULL);
}

Direction GetDirection(Coordinate puc,Coordinate np)
{
      Direction d ;
      int dx,dy   ;

      dx = np.x - puc.x + 1			;
      dy = np.y - puc.y + 1			;
      d  = inverse_unit_direction[dx][dy]	;

      return(d);
}

void CutSegment(Coordinate puc,Coordinate np,HipsImage img)
{
     int i,dx,dy	;
     Coordinate p	;

     for(i=0;i<8;i++)
	{
	 dx = unit_direction[i][0];
	 dy = unit_direction[i][1];
	 if ( (img.UCHARMap[puc.x+dx][puc.y+dy] == _EDGE) &&
	      ( ( puc.x + dx) == np.x )		&&
	      ( ( puc.y + dy) == np.y ) )
	   {
	    p.x = puc.x + dx ;
	    p.y = puc.y + dy ;
	    AddEndPoint(p);
	   }
	}
}

Coordinate GetNextPoint(Coordinate c,Direction d,HipsImage img)
{
   Coordinate p ;
   int dx,dy,i;


   dx  = unit_direction[d][0]	;
   dy  = unit_direction[d][1]	;
   p.x = c.x + dx 		;
   p.y = c.y + dy 		;

     if( (p.x>=0) && (p.x<=img.Row-1) && (p.y>=0) && (p.y<=img.Column-1) )
       {
        if(img.UCHARMap[p.x][p.y] == _EDGE)
          return(p);
       }

     for(i=0;i<4;i++)
      {
       dx = unit_direction[ (d+1+i) % 8][0] ;
       dy = unit_direction[ (d+1+i) % 8][1] ;
       p.x = c.x + dx 		;
       p.y = c.y + dy 		;
       if( (p.x>=0) && (p.x<=img.Row-1) && (p.y>=0) && (p.y<=img.Column-1) )
         if(img.UCHARMap[p.x][p.y] == _EDGE)
	   return(p);
       dx = unit_direction[ (d+7-i) % 8][0] ;
       dy = unit_direction[ (d+7-i) % 8][1] ;
       p.x = c.x + dx 		;
       p.y = c.y + dy 		;
       if( (p.x>=0) && (p.x<=img.Row-1) && (p.y>=0) && (p.y<=img.Column-1) )
         if(img.UCHARMap[p.x][p.y] == _EDGE)
	   return(p);

      }
   return(p);
}

int IsVerifiedEndPoint(Coordinate c)
{
	Endpoint *p		;
	int Found = _FALSE	;

        p = HeaderOfChain ;
        if(p!=NULL)
        do
	  {
	   if( ( (p->point.x)  == c.x ) &&
	       ( (p->point.y)  == c.y ) )  Found = _TRUE ;
	   p = p->next ;
	  }
	while( (p!=NULL) && (Found== _FALSE) );
	return(Found);
}

int IsEndPoint(Coordinate p,HipsImage img)
{
	int end ;

	end = B(p,img) ;
	if ( (end == 1) || (end==0) )
	   return(_TRUE);
	else
	   return(_FALSE);
}

int power(int base,int p)
{
    float r ;
    if(p==0)
       return(1);
    else
       {
	r = pow( (float) base,(float) p) ;
	return((int) r);
       }
}






