#define _EAST		0
#define _NORTHEAST	1
#define _NORTH		2
#define _NORTHWEST	3
#define _WEST		4
#define _SOUTHWEST	5
#define _SOUTH		6
#define _SOUTHEAST	7

#define _FALSE		0
#define _TRUE		1

#define _EDGE		1
#define _NON_EDGE	0
#define _EDGE_255	255

#define _ANGLE_0	0
#define _ANGLE_45	1
#define _ANGLE_90	2
#define _ANGLE_135	3
#define _ANGLE_180	4
#define _ANGLE_225	5
#define _ANGLE_270	6
#define _ANGLE_315	7
#define _ANGLE_360	8

typedef float         ** FloatImage	;
typedef int	      ** IntegerImage	;
typedef char           * FileName	;
typedef unsigned char Angle		;
typedef unsigned char Boolean		;
typedef unsigned char Code		;
typedef short int     Direction		;

typedef struct PROPERTY
        {
         float MeanCurvature 		;
         float MeanGrayLevel 		;
         float StandardDeviation	;
         int   Length	     		;
         float MeanContrast  		;
         int   index			;
         int   priority			;
         int   GrayLevel		;
        } Properties ;

typedef struct PROPERTYWEIGHT
        {
         float CurvatureWeight		;
         float StandardDeviationWeight  ;
         float LengthWeight		;
         float ContrastWeight		;
         float MeanGrayLevelWeight	;
        } PropertyWeight ;

typedef struct coordinate
	{
	 int x	;
	 int y  ;
	} Coordinate	;

typedef struct chaincode
	{
	 Coordinate point				;
	 Direction  dir					;
	 int        Intensity				;
	 short int  WL,WR				;
	 struct chaincode *next				;
	} ChainCode	;

typedef struct endpoint
	{
	 Coordinate point 				;
	 Properties property				;
	 struct endpoint   *next 			;
	 struct endpoint   *before			;
	 short int  WL,WR				;
	 float      *Coeff_Left,*Coeff_Right            ;
	 int        Intensity				;
	 ChainCode  *chain				;
	 ChainCode  *tail				;
	} Endpoint	;

unsigned char inverse_unit_direction[3][3] =
	    { {_NORTHWEST , _NORTH ,_NORTHEAST },
	      {_WEST      , 0      ,_EAST      },
	      {_SOUTHWEST , _SOUTH ,_SOUTHEAST  } };

unsigned char _code_words[10][2] = { { 0 , 0 },
				     {0 , 1 },
				     {4 , 3 },
				     {5 , 3 },
				    {12 , 4 },
				    {13 , 4 },
				    {28 , 5 },
				    {29 , 5 },
				    {30 , 5 },
				    {31 , 5 } };

int rotation[8][8] = { {0 , -1 , -2 , -3 , 4  , 3  , 2 , 1 },
		       {1 ,  0 , -1 , -2 , -3 , 4  , 3 , 2 },
		       {2 ,  1 ,  0 , -1 , -2 , -3 , 4 , 3 },
		       {3 ,  2 ,  1 ,  0 , -1 , -2 ,-3 , 4 },
		       {4 ,  3 ,  2 ,  1 ,  0 , -1 , -2,-3 },
		       {-3,  4 ,  3 ,  2 ,  1 ,  0 , -1,-2 },
		       {-2, -3 ,  4 ,  3 ,  2 ,  1 ,  0 , -1},
		       {-1, -2 , -3 ,  4 ,  3 ,  2 ,  1 ,  0 }} ;

int DIRECTION[3][3] = { {3 ,    2   , 1 },
                        {4 , _FALSE , 0 },
    			{5 ,    6   , 7 }} ;

int unit_direction[8][2] = {{ 0 , 1 },
			    {-1 , 1 },
			    {-1 , 0 },
			    {-1 , -1},
			    { 0 , -1},
			    { 1 , -1},
			    { 1 , 0 },
			    { 1 , 1 }} ;



