#ifndef __CODEC_DEF__
#include "codec_def.h"
#endif
#ifndef __RAWIO__
#include "rawio.h"
#endif

void  Centipede::CompressCentipede(char *filename){
      int i,j,k,l,m,LengthOfEndPoints,nLength,max               ;
      int StartCodeID,c[4],Wleft,Wright                         ;
      RawIO myFile                                              ;

      /* Codec initialization                                   */
      GetTheChainCode()                                         ;
      GetTheDifferentialChainCode()                             ;
      GetTheStatistics()                                        ;
      for(i=0;i<8;i++)
         for(j=0;j<8;j++)
            if(i!=j)
              if((CHAIN_CODE_FRQ[i]<CHAIN_CODE_FRQ[j]) ||
                 ((CHAIN_CODE_FRQ[i]==CHAIN_CODE_FRQ[j])&&(i<j)))
                CodeBookPtr[i]++;
      max = Width                                               ;
      if(max<Height)
        max = Height                                            ;
      for(LengthOfEndPoints=0;max!=0;LengthOfEndPoints++)
         max=max/2;

      /* Openning the file                                      */
      myFile.OpenFile(filename,"wb+")                           ;

      /* Centipede Codec is now running                         */

      /**********************************************************/
      /* Information Packet                                     */
      /**********************************************************/
      StartCodeID = PAC_START_CODE                              ;
      myFile.InsertData(StartCodeID,8)                          ;
      myFile.InsertData(INFO_PAC_START_CODE,8)                  ;
      /* (nRow/Column,Row,Column)                               */
      myFile.InsertData(LengthOfEndPoints,8)                    ;
      myFile.InsertData(Row,LengthOfEndPoints)                  ;
      myFile.InsertData(Column,LengthOfEndPoints)               ;

      /**********************************************************/
      /* Geometry Packet                                        */  
      /**********************************************************/
      StartCodeID = PAC_START_CODE                              ;
      myFile.InsertData(StartCodeID,8)                          ;
      myFile.InsertData(GEOMETRY_PAC_START_CODE,8)              ;
      /* NumOfContours + Dif Chain Code + Huffman               */
      myFile.InsertData(NumberOfContours,8)                     ;

      for(i=0;i<8;i++)
         myFile.InsertData(CodeBookPtr[i],3)               ;
      for(k=0;k<NumberOfContours;k++){
         myFile.InsertData(ContourDescriptor[k].ContourList[0].location.x,
                           LengthOfEndPoints)  ;
         myFile.InsertData(ContourDescriptor[k].ContourList[0].location.y,
                           LengthOfEndPoints)  ;
         myFile.InsertData(ContourDescriptor[k].ContourList[1].ChainCode,3)  ;
         if(ContourDescriptor[k].IsActive == true)
           for(m=2;m<ContourDescriptor[k].ContourLength;m++){
              l=ContourDescriptor[k].ContourList[m].ChainCode       ;
              i=CodeBookForDifferentialChainCode[CodeBookPtr[l]][0] ;
              j=CodeBookForDifferentialChainCode[CodeBookPtr[l]][1] ;
              myFile.InsertData(i,j)                                ;
           }
         i=CodeBookForDifferentialChainCode[CodeBookPtr[7]][0]      ;
         j=CodeBookForDifferentialChainCode[CodeBookPtr[7]][1]      ;
         myFile.InsertData(i,j)                                     ;
      }
      /**********************************************************/
      /* Model Packet                                           */
      /**********************************************************/
      StartCodeID = PAC_START_CODE                                  ;
      myFile.InsertData(StartCodeID,8)                              ;
      myFile.InsertData(MODEL_PAC_START_CODE,8)                     ;
      /* for each contour                                           */
      /*     (nLength2,Wleft,Wright)                                */
      /*     (nLength1,Quantization[c2,c1,c0])                      */
      for(k=0;k<NumberOfContours;k++){
          nLength = 1                                                         ;
          myFile.InsertData(nLength,8)                                     ;
          for(m=0;m<ContourDescriptor[k].ContourLength;m+=nLength){
             Wleft  = ContourDescriptor[k].ContourList[0].WLeft               ;
             Wright = ContourDescriptor[k].ContourList[0].WRight              ;
             myFile.InsertData(Wleft,5)                                       ;
             myFile.InsertData(Wright,5)                                      ;
          }

          nLength = 1                                                         ;
          myFile.InsertData(nLength,8)                                        ;
          for(m=0;m<ContourDescriptor[k].ContourLength;m+=nLength){
  c[0] = (int)ContourDescriptor[k].ContourList[m].OptimalModelParameters[0]+128 ;
  c[1] = (int)ContourDescriptor[k].ContourList[m].OptimalModelParameters[1]+128 ;
  c[3] = (int)ContourDescriptor[k].ContourList[m].OptimalModelParameters[3]+128 ;
   
             myFile.InsertData(c[0],8)                                          ;
             myFile.InsertData(c[1],8)                                          ;
             myFile.InsertData(c[3],9)                                          ;
          }
      }
      myFile.CloseFile()                                                      ;
}

void  Centipede::GetTheStatistics(void){
      int k,l,m                                                               ;


      for(k=0;k<8;k++)

         CHAIN_CODE_FRQ[k] = 0                                                ;


      for(k=0;k<NumberOfContours;k++)
         if(ContourDescriptor[k].IsActive == true){
           CHAIN_CODE_FRQ[7] ++                                               ;
           for(m=1;m<ContourDescriptor[k].ContourLength;m++){
              l = ContourDescriptor[k].ContourList[m].ChainCode               ;
              CHAIN_CODE_FRQ[l] ++                                            ;
           }
         }
}

void  Centipede::GetTheChainCode(void){
      int k,m                                                                 ;
      CoordinateStruct p1,p2                                                  ;

      for(k=0;k<NumberOfContours;k++){
         if(ContourDescriptor[k].IsActive == true)
           for(m=1;m<ContourDescriptor[k].ContourLength;m++){
              p1 = ContourDescriptor[k].ContourList[m-1].location             ;
              p2 = ContourDescriptor[k].ContourList[m].location               ;
              p2 = p2 - p1                                                    ;
              ContourDescriptor[k].ContourList[m].ChainCode =
                        CrossConversion[p2.x+1][p2.y+1]                       ;
         }
      }
}

void  Centipede::GetTheDifferentialChainCode(void){
      int k,m,i,j                                                             ;


      for(k=0;k<NumberOfContours;k++)
         if(ContourDescriptor[k].IsActive == true)
           for(m=ContourDescriptor[k].ContourLength-1;m>=2;m--){
              i = ContourDescriptor[k].ContourList[m].ChainCode               ;
              j = ContourDescriptor[k].ContourList[m-1].ChainCode             ;
              ContourDescriptor[k].ContourList[m].ChainCode =
               CircularDistance[j][i] + 3                                     ;
             }
}

