#ifndef __CODEC_DEF__
#include "codec_def.h"
#endif
#ifndef __RAWIO__
#include "rawio.h"
#endif

void  Centipede::DecodeCentipede(char *filename){
      CoordinateStruct Buffer[1024]                             ;
      int i,j,k,l,m,rawdir,init_dir,nRowColumn,LengthOfEndPoints;
      int StartCodeID,nLength,Wleft,Wright                      ;
      int PacCodeID                                             ;
      float c0,c1,c2,c3                                         ;
      RawIO myFile                                              ;

      myFile.OpenFile(filename,"rb")                            ;
      do{
        StartCodeID=myFile.ReadData(8)                            ;
        if((StartCodeID==0xFF)&&(myFile.EndOfFile == false)){
          PacCodeID=myFile.ReadData(8)                            ;
          switch(PacCodeID){
           case INFO_PAC_START_CODE :
                nRowColumn = myFile.ReadData(8)                   ;
                Row    = Height = myFile.ReadData(nRowColumn)     ;
                Column = Width  = myFile.ReadData(nRowColumn)     ;
                break;
           case MODEL_PAC_START_CODE :
                for(k=0;k<NumberOfContours;k++){
                   nLength=myFile.ReadData(8)                              ;
if(nLength!=0){
     for(l=0;l<ContourDescriptor[k].ContourLength;l += nLength ){
     Wleft  = myFile.ReadData(5)                             ;
     Wright = myFile.ReadData(5)                             ;
       for(m=0;(m<nLength)&&((m+l)<ContourDescriptor[k].ContourLength);m++){
          ContourDescriptor[k].ContourList[l+m].WLeft  = Wleft  ;
          ContourDescriptor[k].ContourList[l+m].WRight = Wright ;
       }
     }
}
else{
  Wleft  = myFile.ReadData(5)                               ;
  Wright = myFile.ReadData(5)                               ;
  for(l=0;l<ContourDescriptor[k].ContourLength;l++){
     ContourDescriptor[k].ContourList[l].WLeft  = Wleft     ;
     ContourDescriptor[k].ContourList[l].WRight = Wright    ;
  }
}

nLength=myFile.ReadData(8)                              ;
if(nLength!=0){
  for(l=0;l<ContourDescriptor[k].ContourLength;l += nLength ){
     c0 = (float) myFile.ReadData(8) - 128.0 ;
     c1 = (float) myFile.ReadData(8) - 128.0 ;
     c3 = (float) myFile.ReadData(9) - 128.0 ;
     for(m=0;(m<nLength)&&((m+l)<ContourDescriptor[k].ContourLength);m++){
        ContourDescriptor[k].ContourList[l+m].OptimalModelParameters[0] = c0  ;
        ContourDescriptor[k].ContourList[l+m].OptimalModelParameters[1] = c1  ;
        ContourDescriptor[k].ContourList[l+m].OptimalModelParameters[2] = -(c0+c1)  ;
        ContourDescriptor[k].ContourList[l+m].OptimalModelParameters[3] = c3  ;
     }
  }
}
else{
  c0 = (float) myFile.ReadData(8) - 128.0 ;
  c1 = (float) myFile.ReadData(8) - 128.0 ;
  c3 = (float) myFile.ReadData(8) - 128.0 ;
  for(l=0;l<ContourDescriptor[k].ContourLength;l++){
        ContourDescriptor[k].ContourList[l+m].OptimalModelParameters[0] = c0  ;
        ContourDescriptor[k].ContourList[l+m].OptimalModelParameters[1] = c1  ;
        ContourDescriptor[k].ContourList[l+m].OptimalModelParameters[2] = -(c0+c1)  ;
        ContourDescriptor[k].ContourList[l+m].OptimalModelParameters[3] = c3  ;
  }
}
                }
                break;
           case GEOMETRY_PAC_START_CODE :
                NumberOfContours = myFile.ReadData(8)             ;
                for(i=0;i<8;i++)
                   CodeBookPtr[i] = myFile.ReadData(3)            ;
      /* Memory allocation for ContourDescriptor                        */
      ContourDescriptor = (ContourDescriptorStruct *)
         malloc(NumberOfContours*sizeof(ContourDescriptorStruct))       ;
                /* Decoding ...*/
                for(k=0,m=0;k<NumberOfContours;k++,m=0){
                ContourDescriptor[k].IsActive = true                  ;
                Buffer[m].x = myFile.ReadData(nRowColumn)             ;
                Buffer[m++].y = myFile.ReadData(nRowColumn)           ;
                ContourDescriptor[k].ContourLength = 2                ;
                init_dir = myFile.ReadData(3)                         ;
                Buffer[m] = Buffer[m-1] + Displacement[init_dir]      ;
                m++;
                while((rawdir=myFile.RawUncompress())!= CodeBookPtr[7]){
                   rawdir = Uncompress(rawdir) ;
                   init_dir = (init_dir + rawdir + 5) % 8 ;
                   Buffer[m] = Buffer[m-1] + Displacement[init_dir]  ;
                   m++;
                   ContourDescriptor[k].ContourLength ++                ;
                }
       ContourDescriptor[k].ContourList = (ContourListStruct *)
                     malloc(ContourDescriptor[k].ContourLength *
                             sizeof(ContourListStruct))                 ;
                for(m=0;m<ContourDescriptor[k].ContourLength;m++)
                   ContourDescriptor[k].ContourList[m].location = Buffer[m] ;
                }
                break;
           default:
                myFile.EndOfFile = true ;
                ShowMessage("End of the file");
                break;
          }
        }else
           break;

      }while(myFile.EndOfFile == false);
}

int Centipede::Uncompress(int r){
    int i;

    for(i=0;i<8;i++)
       if(r == CodeBookPtr[i])
         return i;
}
