void    FindEdgeParameters(FILE *hParam,Endpoint *ptr,HipsImage img,HipsImage eimg,float T,int rw,int cl,
										int BL,int OrderC,int OrderGL,int OrderW) ;
void    SetWidthAlongNormalAndTangentOfSpecifiedDirection(Coordinate c,int GL,Direction dir,
							  float width_right,
							  float width_left,HipsImage beta,HipsImage depth,
							  HipsImage eimg,int AvgRightContrast,int AvgLeftContrast      ,
							  int rw,int cl)							;
void  CopyMatrices(float **Source,float **Destination,int rows,int cols)							;
void  Solve(float **S,float *A,float *M,int Size)										;
void  SetArray(float *Array,float data,int size)										;
float Polynomial(float *A,float k,int Size)											;
void ReadCoefficients(FILE *hFile,int BL,int OrderGL,int OrderC,int OrderW,Endpoint *ptr,HipsImage eimg,HipsImage beta,HipsImage depth,
float **GetS(int BL,int Order)									;													    int rows,int cols)	;
void SaveCoefficients(FILE *hFile,FILE *hParam,int BL,int OrderGl,int OrderC,int OrderW)					;


void SaveCoefficients(FILE *hFile,FILE *hParam,int BL,int OrderGL,int OrderC,int OrderW)
{
     int        k      	;
     float      read	;

     do {
       for(k=0;k<OrderGL;k++){ 
	  fscanf(hFile,"%f\n",&read)	       			;
          if(OrderGL == 1)
	    fprintp(hParam,(int)read,9) 			;
          else
	    fprintp(hParam,(int)(read*10.0 + 256.0) ,9) 	; }
       for(k=0;k<OrderC;k++){ 
	  fscanf(hFile,"%f\n",&read)	       			;
	  fprintp(hParam,(int)(read*10.0 + 256.0) ,9) 		;
	  fscanf(hFile,"%f\n",&read)	       			;
	  fprintp(hParam,(int)(read*10.0 + 256.0) ,9) 		; }
       for(k=0;k<OrderW;k++){ 
	  fscanf(hFile,"%f\n",&read)				;
          if(OrderGL == 1) 
            fprintp(hParam,(int)(read*10.0),4)			;
          else
	    fprintp(hParam,(int)(read*10.0 + 256.0) ,9) 	;
	  fscanf(hFile,"%f\n",&read)	       			;
          if(OrderGL == 1) 
            fprintp(hParam,(int)(read*10.0),4)			;
          else
  	    fprintp(hParam,(int)(read*10.0 + 256.0) ,9) 	; }
     }while (feof(hFile) == 0);
}

void ReadCoefficients(FILE *hFile,int BL,int OrderGL,int OrderC,int OrderW,Endpoint *ptr,HipsImage eimg,HipsImage beta,HipsImage depth,int rows,int cols)
{
     Endpoint   *p						;
     ChainCode  *q,*qi						;
     Coordinate r						;
     Direction  tangent,normal					;
     int        k,l,previous,SL					;
     Boolean    bFull = _FALSE					;
     float      *AGL,*A_Right,*A_Left,*AW_Left,*AW_Right       	;
     if(hFile == NULL) { printf("\n Can not open the file \n"); exit(0); }
     if(BL==0)
       bFull = _TRUE						;
     else
       bFull = _FALSE						;
     printf("\n Polynomial Orders : %d (GrayLevel), %d (Contrast), %d (Width)",OrderGL,OrderC,OrderW); 
     AGL      = (float *) malloc((OrderGL) * sizeof(float))	;
     A_Right  = (float *) malloc((OrderC)  * sizeof(float))	;
     A_Left   = (float *) malloc((OrderC)  * sizeof(float))	;
     AW_Right = (float *) malloc((OrderW)  * sizeof(float))	;
     AW_Left  = (float *) malloc((OrderW)  * sizeof(float))	;
     p  = ptr							;
     if(p!=NULL)
       do{
	  q  = p->chain						;
	  if(bFull == _TRUE) BL = GetSegmentLength(q) - 1	;
          SL = BL						;
          k  = 0						;
          if(BL >= Max(OrderGL,Max(OrderC,OrderW))) 
	  if(q!=NULL)
	    do{
	       qi = q						;
	       for(l=0;l<OrderGL;l++) {
                  if(OrderGL == 1)
                    AGL[l] = (float) fscanp(hFile,8) 			;
                  else 
		    AGL[l] = ( (float) fscanp(hFile,9) - 256.0 ) / 10.0 	; }
	       for(l=0;l<OrderC;l++) { 
		    A_Left[l]  = ( (float) fscanp(hFile,9)  - 256.0 ) / 10.0 	;
		    A_Right[l] = ( (float) fscanp(hFile,9)  - 256.0 ) / 10.0 	; }
	       for(l=0;l<OrderW;l++) {  
                  if(OrderW == 1) {
		    AW_Left[l]  = (float) fscanp(hFile,4)/10.0   	;
		    AW_Right[l] = (float) fscanp(hFile,4)/10.0       ; }
                  else {
		    AW_Left[l]  = ( (float) fscanp(hFile,9)  - 256.0 ) / 10.0 	;
		    AW_Right[l] = ( (float) fscanp(hFile,9)  - 256.0 ) / 10.0 	; } }
	       do{
		tangent = qi->dir				;
                if(qi==p->chain)
                  previous = qi->dir				;

		if( (tangent%2) == 1) {
		  if( ( (tangent == 3) || (tangent == 7) ) && ((previous == 2)||(previous ==6)||(previous ==1)||(previous ==5)))
		    normal = GetNormalDirection((tangent-1)%8)				;
		  else
		    if( ( (tangent == 1) || (tangent == 5) ) && ((previous == 0)||(previous ==4)||(previous==1)||(previous==3)))
		      normal = GetNormalDirection((tangent-1)%8)				;
		    else
		      normal = GetNormalDirection((tangent+1)%8)				; }
		else
		  normal = GetNormalDirection(tangent)						;
		previous = tangent	;
                r = qi->point									;
 		k++										;
		SetWidthAlongNormalAndTangentOfSpecifiedDirection(r,(int) (Polynomial(AGL,(float)k,OrderGL)+0.5),
			   normal,Polynomial(AW_Right,(float)k,OrderW),
			   Polynomial(AW_Left,(float)k,OrderW),beta,depth					 ,
			   eimg,(int)(Polynomial(A_Right,(float)k,OrderC))				,
				      (int)(Polynomial(A_Left,(float)k,OrderC)),rows,cols)			;
		qi = qi->next 										;
                previous = tangent									;
		if (qi!=NULL) r = qi->point		;
	       }
	      while( (qi!=NULL) && ( (k<BL) || ( (SL-BL) < BL ) ) )					;
	      SL = SL - BL									        ;
	    q = qi						;
	 }while(q!=NULL)					;
	p = p->next						;
    }while(p!=NULL)				;
   free(AGL) 							;
   free(A_Left)							;
   free(A_Right)						;
   free(AW_Left)						;
   free(AW_Right)						;
}

void SetWidthAlongNormalAndTangentOfSpecifiedDirection(Coordinate c,int GL,Direction dir,float width_right,float width_left,HipsImage beta,
     HipsImage depth,HipsImage eimg,int AvgRightContrast,int AvgLeftContrast,int rw,int cl)
{
    int        distance,dx,dy								;
    Direction  normal,pnormal	  							;
    Coordinate s,t									;
    Boolean    InsideDomain								;
    float      l,unit_distance								;

    normal  = dir 						 			;
    pnormal = RotateDirection(normal,_ANGLE_180)					;
    beta [c.x][c.y] = _EDGE_255								;
    if(GL<0)
      GL = 0	;
    else
    if(GL>255)
      GL = 255	;
    depth[c.x][c.y] = GL								;
    /*printf("\n      Real (EDGE) - New %d %d",img[c.x][c.y],GL) ;*/
    l = 0.0										;
    t = c										;
    unit_distance = 1.0	;
    do
      {
       dx  = unit_direction[normal][0]							;
       dy  = unit_direction[normal][1]							;
       s.x = t.x + dx                          						;
       s.y = t.y + dy                          						;
       InsideDomain = CheckCoordinate(s,rw,cl) 						;
       if(InsideDomain == _TRUE)
	 {
	  t   = s                                       				;
	  l  += unit_distance								;
	 }
      }
    while((l<width_right)&&(InsideDomain == _TRUE))					;
    if( eimg[t.x][t.y] == _NON_EDGE)
      {
       if( ( GL + AvgRightContrast ) > 255 )
	    depth[t.x][t.y] = 255							;
       else
       if( ( GL + AvgRightContrast ) < 0 )
	 depth[t.x][t.y] = 0								;
       else
	   depth[t.x][t.y] = GL + AvgRightContrast 			       		;
	beta[t.x][t.y]  = _EDGE_255                                      		;
       /*printf("\n      Real (Right) %d %d" ,depth[t.x][t.y],AvgRightContrast) 		;
       */}
    /* Other Normal Direction								*/
    l = 0.0										;
    t = c										;
    do
      {
       dx  = unit_direction[pnormal][0]							;
       dy  = unit_direction[pnormal][1]							;
       s.x = t.x + dx                          						;
       s.y = t.y + dy                          						;
       InsideDomain = CheckCoordinate(s,rw,cl) 						;
      if(InsideDomain == _TRUE)
	 {
	  t   = s                                       				;
	  l  += unit_distance								;
	 }
      }
    while((l<width_left)&&(InsideDomain == _TRUE))					;
    if( eimg[t.x][t.y] == _NON_EDGE)
      {
       if( ( GL + AvgLeftContrast ) > 255 )
	 depth[t.x][t.y] = 255								;
       else
       if( ( GL + AvgLeftContrast ) < 0 )
	 depth[t.x][t.y] = 0								;
       else
	 depth[t.x][t.y] =  GL + AvgLeftContrast       					;
       beta[t.x][t.y]  = _EDGE_255                                      		;
    /*printf("\n      Real (Left) %d %d" ,depth[t.x][t.y],AvgLeftContrast) 		;
   */}
}

void FindEdgeParameters(FILE *hParam,Endpoint *ptr,HipsImage img,HipsImage eimg,float T,
			int rw,int cl,int BL,int OrderC,int OrderGL,int OrderW)
{
     Endpoint   *p								;
     ChainCode  *q,*qi								;
     int        dx,dy,i,j,k,m,sign,x,y,SL,bl				       	;
     Direction  tangent,normal,pnormal,previous1,previous2            		;
     Coordinate r,s,t								;
     float      grt,Dif_right,Dif_left,AvgRightContrast,AvgLeftContrast 	;
     float      unit_distance,l,w_right,w_left					;
     float      *M_Left,*M_Right,*A_Left,*A_Right,**S_Left,**S_Right		;
     float      *AW_Left,*AW_Right,*MW_Left,*MW_Right,**SW_Left,**SW_Right	;
     float      *AGL,*MGL,**SGL,step_size,rotate_angle,f,st_angle,angle_step	;
     float      **SC_Buffer,**SGL_Buffer,**SW_Buffer				;
     Boolean    InsideDomain,Change,Current,bFull = _FALSE			;

     SGL_Buffer = (float **) alloc_2Darray(OrderGL,OrderGL,sizeof(float))	;
     SC_Buffer  = (float **) alloc_2Darray(OrderGL,OrderC,sizeof(float))	;
     SW_Buffer  = (float **) alloc_2Darray(OrderGL,OrderW,sizeof(float))	;
     SGL        = (float **) alloc_2Darray(OrderGL,OrderGL,sizeof(float))	;
     SW_Left    = (float **) alloc_2Darray(OrderW,OrderW,sizeof(float))		;
     SW_Right   = (float **) alloc_2Darray(OrderW,OrderW,sizeof(float))		;
     S_Left     = (float **) alloc_2Darray(OrderC,OrderC,sizeof(float))		;
     S_Right    = (float **) alloc_2Darray(OrderC,OrderC,sizeof(float))		;

     M_Left     = (float *) malloc(OrderC*sizeof(float))			;
     M_Right    = (float *) malloc(OrderC*sizeof(float))			;
     MW_Left    = (float *) malloc(OrderW*sizeof(float))			;
     MW_Right   = (float *) malloc(OrderW*sizeof(float))			;
     MGL        = (float *) malloc(OrderGL*sizeof(float))			;

     A_Left   = (float *) malloc(OrderC*sizeof(float))				;
     A_Right  = (float *) malloc(OrderC*sizeof(float))				;
     AW_Left  = (float *) malloc(OrderW*sizeof(float))				;
     AW_Right = (float *) malloc(OrderW*sizeof(float))				;
     AGL      = (float *) malloc(OrderGL*sizeof(float))				;

     if(BL==0)
       bFull = _TRUE								;
     else
       bFull = _FALSE								;
     /* Block Length != 0 							*/
     if(bFull==_FALSE)
       {
	for(i=0;i<OrderGL;i++)
	   for(j=0;j<OrderGL;j++)
	      SGL_Buffer[i][j] = 0.0						;
	for(i=0;i<OrderC;i++)
	   for(j=0;j<OrderC;j++)
	      SC_Buffer [i][j] = 0.0						;
	for(i=0;i<OrderW;i++)
	   for(j=0;j<OrderW;j++)
	      SW_Buffer [i][j] = 0.0						;
	for(k=1;k<=BL;k++) {
	   for(i=0;i<OrderGL;i++)
	      for(j=0;j<OrderGL;j++)
		 SGL_Buffer[i][j] += (float) pow(k,i+j)				;
	   for(i=0;i<OrderW;i++)
	      for(j=0;j<OrderW;j++)
		 SW_Buffer[i][j] += (float) pow(k,i+j)				;
	   for(i=0;i<OrderC;i++)
	      for(j=0;j<OrderC;j++)
		 SC_Buffer[i][j] += (float) pow(k,i+j)				; }
       }
     bl = BL									;
     p = ptr									;
     if(p!=NULL)
       do {
	   q = p->chain								;
	   r = q->point								;
           BL = bl								;
	   SL = GetSegmentLength(q) - 1 					;
	   /* Block Length = 0							*/
	   if(bFull == _TRUE){
	   BL = SL								;
	   for(i=0;i<OrderGL;i++)
	      for(j=0;j<OrderGL;j++)
		 SGL_Buffer[i][j] = 0.0						;
	   for(i=0;i<OrderC;i++)
	      for(j=0;j<OrderC;j++)
		 SC_Buffer [i][j] = 0.0						;
	   for(i=0;i<OrderW;i++)
	      for(j=0;j<OrderW;j++)
		 SW_Buffer [i][j] = 0.0						;
	   for(k=1;k<=BL;k++) {
	      for(i=0;i<OrderGL;i++)
		 for(j=0;j<OrderGL;j++)
		    SGL_Buffer[i][j] += (float) pow(k,i+j)			;
	      for(i=0;i<OrderW;i++)
		 for(j=0;j<OrderW;j++)
		       SW_Buffer[i][j] += (float) pow(k,i+j)			;
	      for(i=0;i<OrderC;i++)
		 for(j=0;j<OrderC;j++)
		    SC_Buffer[i][j] += (float) pow(k,i+j)			; }
	   }
           else
           {
            BL = Min(BL,SL)								;
	    for(i=0;i<OrderGL;i++)
	       for(j=0;j<OrderGL;j++)
		  SGL_Buffer[i][j] = 0.0						;
	    for(i=0;i<OrderC;i++)
	       for(j=0;j<OrderC;j++)
		  SC_Buffer [i][j] = 0.0						;
	    for(i=0;i<OrderW;i++)
	       for(j=0;j<OrderW;j++)
		  SW_Buffer [i][j] = 0.0						;
	    for(k=1;k<=BL;k++) {
	       for(i=0;i<OrderGL;i++)
		  for(j=0;j<OrderGL;j++)
		    SGL_Buffer[i][j] += (float) pow(k,i+j)			;
	      for(i=0;i<OrderW;i++)
		 for(j=0;j<OrderW;j++)
		       SW_Buffer[i][j] += (float) pow(k,i+j)			;
	      for(i=0;i<OrderC;i++)
		 for(j=0;j<OrderC;j++)
		    SC_Buffer[i][j] += (float) pow(k,i+j)			; }
           }
           if(BL >= Max(OrderGL,Max(OrderC,OrderW)))
	   if(q!=NULL)
	     do {
	     qi = q								;
	     AvgRightContrast = 0.0						;
	     AvgLeftContrast  = 0.0						;
	     k = 0								;
	     CopyMatrices(SC_Buffer ,S_Left  ,OrderC ,OrderC)			;
	     CopyMatrices(SC_Buffer ,S_Right ,OrderC ,OrderC)			;
	     CopyMatrices(SW_Buffer ,SW_Left ,OrderW ,OrderW)			;
	     CopyMatrices(SW_Buffer ,SW_Right,OrderW ,OrderW)			;
	     CopyMatrices(SGL_Buffer,SGL     ,OrderGL,OrderGL)			;
	     /* Set initial values to ZERO					*/
	     SetArray(A_Left  ,0.0,OrderC)					;
	     SetArray(A_Right ,0.0,OrderC)					;
	     SetArray(AW_Left ,0.0,OrderW)					;
	     SetArray(AW_Right,0.0,OrderW)					;
	     SetArray(AGL     ,0.0,OrderGL)					;
	     SetArray(M_Left  ,0.0,OrderC)					;
	     SetArray(M_Right ,0.0,OrderC)					;
	     SetArray(MW_Left ,0.0,OrderW)					;
	     SetArray(MW_Right,0.0,OrderW)					;
	     SetArray(MGL     ,0.0,OrderGL)					;
	     /******************************************************************/
	     /* 1st pass to find Average Contrast		               */
	     /******************************************************************/
	     do
	       {
		if(qi==p->chain)
		  previous1 = qi->dir									;
		tangent = qi->dir 						;
		if( (tangent%2) == 1) {
		  if( ( (tangent == 3) || (tangent == 7) ) && ((previous1 == 2)||(previous1 ==6)||(previous1 ==1)||(previous1 ==5)))
		    normal = GetNormalDirection((tangent-1)%8)				;
		  else
		    if( ( (tangent == 1) || (tangent == 5) ) && ((previous1 == 0)||(previous1 ==4)||(previous1==1)||(previous1==3)))
		      normal = GetNormalDirection((tangent-1)%8)				;
		    else
		      normal = GetNormalDirection((tangent+1)%8)				; }
		else
		  normal = GetNormalDirection(tangent)						;
		previous1 = tangent								;
		pnormal = RotateDirection(normal,_ANGLE_180)					;
		/* Normal Direction					       			*/
		l = 0.0								;
		t = r								;
		k++								;
		/*
		if(((normal/2) * 2 ) == normal )
		  unit_distance = 1.0	;
		else
		  unit_distance = 1.41	;
		*/
		unit_distance = 1.0	;
		dx  = unit_direction[normal][0]				;
		dy  = unit_direction[normal][1]				;
		s.x = t.x + dx						;
		s.y = t.y + dy					       	;
		InsideDomain = CheckCoordinate(s,rw,cl)			;
		if( InsideDomain == _TRUE)
		  {
		   grt = (float)img[s.x][s.y] - (float)img[t.x][t.y]   	;
		   if(grt<0.0) {
		      grt = 0.0 - grt;
		      Change = _FALSE;}
		   else Change = _TRUE	;
		      t   = s						       	;
		      l  += unit_distance					;
		  }

		do
		  {
		   dx  = unit_direction[normal][0]				;
		   dy  = unit_direction[normal][1]				;
		   s.x = t.x + dx						;
		   s.y = t.y + dy					       	;
		   InsideDomain = CheckCoordinate(s,rw,cl)			;
		   if( InsideDomain == _TRUE)
		     {
		      grt = (float)img[s.x][s.y] - (float)img[t.x][t.y]   	;
		      if(grt<=0.0) {
			grt = 0.0 - grt						;
			Current = _FALSE ; }
		      else Current = _TRUE					;
		      if( Current == Change ) {
			t  = s						       	;
			l += unit_distance					;
		       }
		    }
		  }
		while((grt>T)&&(l<8.0)&&(InsideDomain == _TRUE)&&(Current == Change));
		Dif_right = (float) img[t.x][t.y] - (float) img[r.x][r.y]		;
		for(i=0;i<OrderC;i++)
		   M_Right[i]  += Dif_right * (float) pow(k,i) 		;
		for(i=0;i<OrderW;i++)
		   MW_Right[i] += (float) l * (float) pow(k,i) 				;
		AvgRightContrast += Dif_right						;
		/***********************************************************************/
		/* Other normal direction 				       	       */
		/***********************************************************************/
		/*
		if(((pnormal/2) * 2 ) == pnormal )
		  unit_distance = 1.0							;
		else
		  unit_distance = 1.41							;
		*/
		l = 0.0									;
		t = r									;

		dx  = unit_direction[pnormal][0]			;
		dy  = unit_direction[pnormal][1]			;
		s.x = t.x + dx						;
		s.y = t.y + dy					       	;
		InsideDomain = CheckCoordinate(s,rw,cl)			;
		if( InsideDomain == _TRUE)
		  {
		   grt = (float)img[s.x][s.y] - (float)img[t.x][t.y]   	;
		   if(grt<0.0) {
		      grt = 0.0 - grt;
		      Change = _FALSE;}
		   else Change = _TRUE	;
		      t   = s						       	;
		      l  += unit_distance					;
		     }

		do
		 {
		  dx  = unit_direction[pnormal][0]				;
		  dy  = unit_direction[pnormal][1]				;
		  s.x = t.x + dx						;
		  s.y = t.y + dy					       	;
		  InsideDomain = CheckCoordinate(s,rw,cl)			;
		  if( InsideDomain == _TRUE)
		    {
		     grt = (float)img[s.x][s.y] - (float)img[t.x][t.y]   	;
		     if(grt<=0.0) {
		       grt = 0.0 - grt						;
		       Current = _FALSE ; }
		     else Current = _TRUE					;
		     if(Current == Change){
		       t = s						       	;
		       l+= unit_distance					;
		      }
		    }
		 }
	       while((grt>T)&&(l<8.0)&&(InsideDomain == _TRUE)&&(Current==Change))	;
	       Dif_left = (float) img[t.x][t.y] - (float) img[r.x][r.y]			;
	       for(i=0;i<OrderC;i++) 
		  M_Left [i] +=  Dif_left * (float) pow(k,i) 				;
	       for(i=0;i<OrderW;i++)
		  MW_Left[i] += (float) l             * (float) pow(k,i) 		;
	       for(i=0;i<OrderGL;i++)
		  MGL    [i] += (float) img[r.x][r.y] * (float) pow(k,i) 		;
	       AvgLeftContrast += Dif_left						;
	       qi = qi->next 								;
	       if(qi!=NULL) r = qi->point						;
	      }
	    while( (qi!=NULL) && ( (k<BL) || ( (SL-BL) < BL ) ) )			;
	    /* Average Left and Right Contrast 				               */
	    AvgRightContrast /= (float) k				        	;
	    AvgLeftContrast  /= (float) k				        	;
	    if( (SL-BL) < BL ) {
	       for(i=0;i<OrderGL;i++)
	          for(j=0;j<OrderGL;j++)
		     SGL_Buffer[i][j] = 0.0						;
	       for(i=0;i<OrderC;i++)
	          for(j=0;j<OrderC;j++)
		     SC_Buffer [i][j] = 0.0						;
	       for(i=0;i<OrderW;i++)
	          for(j=0;j<OrderW;j++)
		     SW_Buffer [i][j] = 0.0						;
	       for(m=1;m<=k;m++) {
		  for(i=0;i<OrderGL;i++)
		     for(j=0;j<OrderGL;j++)
			SGL_Buffer[i][j] += (float) pow(m,i+j)			;
		  for(i=0;i<OrderW;i++)
		     for(j=0;j<OrderW;j++)
			SW_Buffer[i][j] += (float) pow(m,i+j)			;
		  for(i=0;i<OrderC;i++)
		     for(j=0;j<OrderC;j++)
			SC_Buffer[i][j] += (float) pow(m,i+j)			; }
		CopyMatrices(SC_Buffer ,S_Left  ,OrderC ,OrderC)			;
		CopyMatrices(SC_Buffer ,S_Right ,OrderC ,OrderC)			;
		CopyMatrices(SW_Buffer ,SW_Left ,OrderW ,OrderW)			;
		CopyMatrices(SW_Buffer ,SW_Right,OrderW ,OrderW)			;
		CopyMatrices(SGL_Buffer,SGL     ,OrderGL,OrderGL)			;
	       } /* if( (SL ...    */
	    Solve(S_Left  ,A_Left  ,M_Left  ,OrderC)					;
	    Solve(S_Right ,A_Right ,M_Right ,OrderC)					;
	    Solve(SGL     ,AGL     ,MGL     ,OrderGL)					;
	    Solve(SW_Left ,AW_Left ,MW_Left ,OrderW)					;
	    Solve(SW_Right,AW_Right,MW_Right,OrderW)					;
	    for(i=0;i<OrderGL;i++) 
	       fprintf(hParam,"%f\n",AGL[i])						;
	    for(i=0;i<OrderC;i++){ 
	       fprintf(hParam,"%f\n",A_Left[i])						;
	       fprintf(hParam,"%f\n",A_Right[i])						; }
	    for(i=0;i<OrderW;i++){ 
	       fprintf(hParam,"%f\n",AW_Left[i])						;
	       fprintf(hParam,"%f\n",AW_Right[i])					; }
	   q = qi											;
	  }while(q!=NULL)										;
	  p = p->next											;
	 }
       while(p!=NULL)											;
       for(k=0;i<OrderGL;i++) {
	  free(SGL_Buffer[i])										;
	  free(SGL       [i])										; }
       for(k=0;i<OrderW;i++) {
	  free(SW_Buffer [i])										;
	  free(SW_Left   [i])										;
	  free(SW_Right  [i])										; }
       for(k=0;i<OrderC;i++) {
	  free(SC_Buffer [i])										;
	  free(S_Left    [i])										;
	  free(S_Right   [i])										; }
       free(SGL_Buffer)											;
       free(SW_Buffer )											;
       free(SC_Buffer )											;
       free(S_Left    )											;
       free(M_Left    )											;
       free(A_Left    ) 											;
       free(S_Right   )											;
       free(M_Right   )											;
       free(A_Right   )											;
       free(SW_Right  )											;
       free(MW_Right  )											;
       free(AW_Right  )											;
       free(SW_Left   )											;
       free(MW_Left   )											;
       free(AW_Left   )											;
       free(SGL       )											;
       free(MGL       )											;
       free(AGL       )											;
}

void CopyMatrices(float **Source,float **Destination,int rows,int cols)
{
     int i,j	;
     for(i=0;i<rows;i++)
	for(j=0;j<cols;j++)
	   Destination[i][j] = Source[i][j] ;
}

void SetArray(float *Array,float data,int size)
{
     int i	;

     for(i=0;i<size;i++)
	Array[i] = data	;
}

float Polynomial(float *A,float k,int Size)
{
      int   i				;
      float p				;

      p = 0.0				;
      for(i=0;i<Size;i++)
	 p += A[i] * (float) pow(k,i) 	;
      return(p)				;
}

void Solve(float **S,float *A,float *M,int N)
{
     float pivot				;
     int   i,j,k				;

     if(N>1)
     for(i=0;i<N-1;i++)
	for(j=i+1;j<N;j++) {
	   pivot   = - S[j][i] / S[i][i] 	;
	   S[j][i] = 0.0			;
	   for(k=i+1;k<N;k++)
	      S[j][k] += pivot * S[i][k]        ;
	   M[j] += pivot * M[i]			; }

     A[N-1] = M[N-1] / S[N-1][N-1]		;
     if(N>1)
     for(k=N-2;k>=0;k--) {
	A[k] = M[k]				;
	for(i=N-1;i>k;i--)
	   A[k] -= S[k][i] * A[i]		;
	A[k] /= S[k][k]				; }
}

float **GetS(int BL,int Order)
{
      float **S			;
      int i,j,k			;

	for(k=1;k<=BL;k++) {
	   for(i=0;i<Order;i++)
	      for(j=0;j<Order;j++)
		 S[i][j] += (float) pow(k,i+j)				;
        
       return(S);
}
