/*******************************************************************/
/* Perceptual Grouping                                             */
/*******************************************************************/
int   myABS(int value){
      if(value>=0)
        return value ;
      else
        return -value ;      
}

void  Centipede::PerceptualGrouping(float weightLength,
                                    float weightCurvature,
                                    float weightContrast,int indexThreshold){

      int k,m                                             ;
      float meanContrast,meanCurvature                    ;
      float contrastLeft,contrastRight                    ;

      if(HasContourDescriptorExtracted == true){
        for(k=0;k<NumberOfContours;k++){
           ContourDescriptor[k].Property.Length =
                    ContourDescriptor[k].ContourLength    ;
           meanContrast  = 0.0                            ;
           meanCurvature = 0.0                            ;
           for(m=0;m<ContourDescriptor[k].ContourLength;m++){
           contrastLeft  = myABS(ContourDescriptor[k].ContourList[m].CLeft)   ;
           contrastRight = myABS(ContourDescriptor[k].ContourList[m].CRight)  ;
           meanContrast  += (contrastLeft + contrastRight) / 2.0       ;
           if(m>0)
             meanCurvature +=
                fabs(ContourDescriptor[k].ContourList[m].normalVect -
                     ContourDescriptor[k].ContourList[m-1].normalVect ) ;
           }
           ContourDescriptor[k].Property.MeanContrast = (int)
              ( ( meanContrast / (float) ContourDescriptor[k].Property.Length )
                + 0.5 ) ;
           ContourDescriptor[k].Property.MeanCurvature =
              ( meanCurvature / ContourDescriptor[k].Property.Length ) ;
           if(MaximumContrast<= ContourDescriptor[k].Property.MeanContrast)
             MaximumContrast = ContourDescriptor[k].Property.MeanContrast ;
           if(MaximumCurvature<= ContourDescriptor[k].Property.MeanCurvature)
             MaximumCurvature = ContourDescriptor[k].Property.MeanCurvature ;
        }
        /* Normalizing the weights */
        weightLength   /= (float) MaximumContourLength               ;
        weightContrast /= (float) MaximumContrast                    ;
        weightCurvature /= (float) MaximumCurvature                   ;
        for(k=0;k<NumberOfContours;k++){
         ContourDescriptor[k].Property.PerceptualSignificance =
          weightLength   * (float) ContourDescriptor[k].Property.Length +
          weightContrast * (float) ContourDescriptor[k].Property.MeanContrast +
          weightCurvature* (float) ContourDescriptor[k].Property.MeanCurvature ;
        }
        for(k=0;k<NumberOfContours;k++){
           ContourDescriptor[k].Property.Index = 1 ;
           for(m=0;m<NumberOfContours;m++)
              if(k!=m)
                if(ContourDescriptor[k].Property.PerceptualSignificance<
                   ContourDescriptor[m].Property.PerceptualSignificance)
                   ContourDescriptor[k].Property.Index++ ;
        }
        for(k=0;k<NumberOfContours;k++)
           if(ContourDescriptor[k].Property.Index > indexThreshold)
              ContourDescriptor[k].IsActive = false ;
           else
              ContourDescriptor[k].IsActive = true ;           
      }
}
