#ifndef __RAWIO__
#define __RAWIO__
#endif

class RawIO{
      public:
            RawIO()                                     ;
           ~RawIO()                                     ;
      bool OpenFile(char *,char *)                      ;
      bool CloseFile()                                  ;
      bool InsertData(int,int)                          ;
      int  ReadData(int)                                ;
      int  RawUncompress(void)                          ;
      bool EndOfFile                                    ;

      private:
      void WriteToFile(void)                            ;
      bool InsertData_8(int,int)                        ;
      int  ReadData_8(int)                              ;
      bool IsFileOpened                                 ;
      char *FileName                                    ;
      char Buffer                                       ;
      short int BitPointer                              ;
      short int AvailableSize                           ;
      short int ReadBits                                ;
      FILE *hFile                                       ;
};

        RawIO::RawIO(){
        EndOfFile = false                               ;
        BitPointer = 1                                  ;
        IsFileOpened = false                            ;
        Buffer = 0                                      ;
        AvailableSize = 8                               ;
        ReadBits = 0                                    ;
        hFile = NULL                                    ;
}

        RawIO::~RawIO(){
}

int RawIO::RawUncompress(void){
    int onebit,i=0          ;

    do{
     onebit = ReadData(1) ;
     if(onebit)
       i++ ;
    }while( (onebit != 0) && (i<7));
    return i ;
}

bool RawIO::OpenFile(char *filename,char *mode){
     FileName = (char *) malloc(256 * sizeof(char))     ;
     strcpy(FileName,filename)                          ;
     hFile = fopen(FileName,mode)                       ;
     if(hFile == NULL){
       EndOfFile = false                                ;
       return false                                     ;
     }
     EndOfFile = true                                   ;       
     IsFileOpened = true                                ;
     return true                                        ;
}

bool RawIO::CloseFile(void){
     if(IsFileOpened == true){
        WriteToFile()                                   ;     
        EndOfFile = true                                ;     
        fclose(hFile)                                   ;
        BitPointer = 1                                  ;
        IsFileOpened = false                            ;
        Buffer = 0                                      ;
        AvailableSize = 8                               ;
        ReadBits = 0                                    ;
        hFile = NULL                                    ;
       return true                                      ;
     }
     else
       return false                                     ;
}

int  RawIO::ReadData(int Length){
     int  send = 0,read  ;

     if(Length<=8){
       read = ReadData_8(Length) ;
       return read ;
     }else{
       send = ReadData_8(Length-8) ;
       read = ReadData_8(8)        ;
       send = send << 8            ;
       send = send | read          ;
       return send                 ;
     }
}

int  RawIO::ReadData_8(int Length){
     int  send = 0,read                                 ;
     short int mask,hold,i                              ;

     if(ReadBits==0){
       EndOfFile = ((read=fscanf(hFile,"%c",&Buffer))==0) ;
       ReadBits=8;
     }

     if(ReadBits >= Length){
       send = (int) Buffer ;
       if(ReadBits > Length)
         send >>= (ReadBits - Length) ;
       for(i=0,mask=1;i<Length;i++)
          mask <<= 1 ;
       mask-- ;
       send &= mask ;
       ReadBits = ReadBits - Length ;
     }else{
       send = Buffer                ;
       EndOfFile = ((read=fscanf(hFile,"%c",&Buffer))==0) ;
       for(i=0,mask=1;i<ReadBits;i++)
          mask <<= 1 ;
       mask-- ;
       send &= mask ;
       hold = Buffer ;
       hold >>= (8-Length+ReadBits) ;
       send <<= (Length-ReadBits)   ;
       for(i=0,mask=1;i<(Length-ReadBits);i++)
          mask <<= 1 ;
       mask-- ;
       hold &= mask ;
       send |= hold ;
       ReadBits = 8 - Length + ReadBits ;
     }
     return send;
}

bool RawIO::InsertData(int Data,int Length){
     int InsertedData,tmp                                       ;

     if(Length<=8){
       InsertData_8(Data,Length)                                ;
       return true                                              ;
     }else{
       InsertedData = Data                                      ;
       InsertedData = InsertedData >> 8                         ;
       InsertData_8(InsertedData,Length-8)                      ;
       InsertedData = Data & 255                                ;
       InsertData_8(InsertedData,8)                             ;
       return true                                              ;
     }
}

bool RawIO::InsertData_8(int Data,int Length){
     int InsertedData,tmp                                       ;

     if(AvailableSize >= Length){
       if(AvailableSize > Length)
         InsertedData = Data << (AvailableSize - Length )       ;
       else
         InsertedData = Data                                    ;
       Buffer = Buffer | InsertedData                           ;
       BitPointer = BitPointer + Length                         ;
       AvailableSize -= Length                                  ;
       if(BitPointer>8)
         WriteToFile()                                          ;
       return true                                              ;
     }
     else{
       tmp = Length - AvailableSize                             ;
       InsertedData = Data >> tmp                               ;
       Buffer = Buffer | InsertedData                           ;
       WriteToFile()                                            ;
       InsertedData = Data & ( (int)pow(2, tmp ) - 1)           ;
       InsertedData <<= 8 - tmp                                 ;
       Buffer = Buffer | InsertedData                           ;
       BitPointer = BitPointer + tmp                            ;
       AvailableSize = 8 - tmp                                  ;
       return true                                              ;
     }
}

void RawIO::WriteToFile(){
     fprintf(hFile,"%c",Buffer)                                 ;
     Buffer = 0                                                 ;
     BitPointer = 1                                             ;
     AvailableSize = 8                                          ;
}
