#define U	010
#define E	020
#define I	040
#define MM	0100
#define M	0200
#define	NMM	1000
#define absval(f) (((f)<0)?(-(f)):(f))

int flagpass[4] = {0,0,0,0};       
int flags = 0;
int flagv = 0;

int rinc[10] = {0,0,-1,-1,-1,0,1,1,1,0}			;
int cinc[10] = {0,1,1,0,-1,-1,-1,0,1,1}			;
int mrow[NMM],mcol[NMM],mlabel[NMM],maxmult,maxlabel	;
char *pic						;

void fthip (unsigned char **,int ,int )			;
void thinHIPS(int,int)					;
int neighbor(int ,int ,int ,int ,int )                  ;
void addmult(int ,int ,int )                            ;

void fthip (unsigned char **image,int rows,int cols)
{
  int rw, cl;

  pic = (char *) malloc(rows*cols*sizeof(char));

    for(rw=0; rw<rows; rw++)
      for (cl=0; cl<cols; cl++)
        pic[rw*cols+cl] = (char) *(image[rw]+cl);
 
  thinHIPS(rows,cols);

  for(rw=0; rw<rows; rw++)
     for (cl=0; cl<cols; cl++)
        image[rw][cl] = (uchar) pic[rw*cols+cl];

  free((char*)pic);

  printf("fthip: Done.\n");
}

void thinHIPS(int row,int col)
{
	int frameno,r,c,change,trans,neigh,pass,first,gap,gapopen;
	int i,j ;
	int mini,sumr,sumc,label,npt,Mfound;
	float avgr,avgc,mindist,dist;
	char *ppic;

	if (flagpass[0]==0 && flagpass[1]==0 && flagpass[2]==0 &&
		flagpass[3]==0)
		flagpass[0]=flagpass[1]=1;

	for (frameno=0;frameno<1;frameno++) {            /* assumed to be one frame ! */


	    for (pass=0;pass<4;pass++)
		if (flagpass[pass]) {

		    do {
			maxlabel = maxmult = change = 0;

			ppic = pic;

			/*  neighborhood:  432
					   501
					   678
		    	and 9 = 1 for modular arithmetic */

		    for (r=0;r<row;r++) {
			for (c=0;c<col;c++) {
				if ((*ppic&0377)!=0) {
				    switch(pass) {

				    case 0:
				    case 2:
					neigh = trans = 0;
					for (i=1;i<=8;i++) {
						if (neighbor(r,c,i,row,col)!=0)
							neigh++;
						if (((neighbor(r,c,i,row,col)==0) ^
						    (neighbor(r,c,i+1,row,col)==0))!=0)
							trans++;
					}
					if (pass==0) {
					    if (trans==2 && neigh>2 && neigh<6) {
						*ppic++ = 0;
						change++;
					    }
					    else
						ppic++;
					}
					else {   /* pass 2 */
					    if (trans == 2 && neigh < 3)
						*ppic++ = E;
					    else if (neigh == 0)
						*ppic++ = I;
					    else if (trans >= 6)
						*ppic++ = M;
					    else if (neigh > 2)
						*ppic++ = MM;
					    else
						*ppic++ = U;
					}
					continue;

				    case 1:
					neigh = trans = 0;
					for (i=1;i<=8;i++) {
						if (neighbor(r,c,i,row,col)) {
							neigh++;
							first = i;
						}
                                                if (((neighbor(r,c,i,row,col)==0) ^
						    (neighbor(r,c,i+1,row,col)==0))!=0)
							trans++;
					}
					if (neigh<2 || neigh>6 || 
					    (neigh==2 && trans<4) ||
					    (neigh==3 && trans>4)) {
						ppic++;
						continue;
					}
					gap = gapopen = 0;
					for (i=first+1;i<first+8;i++) {
					    j = ((i - 1) % 8) + 1;
					    if (gapopen) {
						if (neighbor(r,c,j,row,col))
							gapopen = 0;
					    }
					    else {
						if (j%2==1 && neighbor(r,c,j,row,col)==0) {
							gapopen++;
							gap++;
						}
					    }
					}
					if (gap == 1) {
						*ppic++ = 0;
						change++;
					}
					else
						ppic++;
					continue;

				    case 3:
					if ((*ppic&0377)==MM || (*ppic&0377)==M) {
					    ppic++;
					    first = 0;
					    for (i=1;i<=8;i++) {
						if (neighbor(r,c,i,row,col)==MM || neighbor(r,c,i,row,col)==M) {
						    if (first++ == 0)
							addmult(r,c,++maxlabel);
						    addmult(r+rinc[i],
							c+cinc[i],maxlabel);
						}
					    }
					}
					else
						ppic++;
					continue;

				    default:
					perror("unknown pass!"); /*IE*/
				    }
				}
				else
					ppic++;
		        }
		    }

		    if (pass == 3) {
			while (1) {
			    label = 0;
			    for (i=0;i<maxmult;i++)
				if ((label = mlabel[i]) != 0)
				    break;
			    if (label == 0)
				break;
			    Mfound = sumr = sumc = npt = 0;
			    for (i=0;i<maxmult;i++)
				if (mlabel[i] == label) {
				    sumr += mrow[i];
				    sumc += mcol[i];
				    if ((*(pic + mrow[i]*col+mcol[i])&0377) == M)
					Mfound++;
				    npt++;
				}
			    if (Mfound) {
				for (i=0;i<maxmult;i++) {
					if (mlabel[i] == label)
						mlabel[i] = 0;
				}
				continue;
			    }
			    if (npt < 2)
				perror("only one M point!??"); /*IE*/
			    avgr = ((float) sumr)/npt;
			    avgc = ((float) sumc)/npt;
			    mindist = 10000000.;
			    for (i=0;i<maxmult;i++) {
				if (mlabel[i] == label) {
				    dist = absval(avgr-mrow[i]) +
					absval(avgc-mcol[i]);
				    if (dist<mindist) {
					mindist = dist;
					mini = i;
				    }
				}
			    }
			    for (i=0;i<maxmult;i++) {
				if (mlabel[i]==label) {
				    if (i == mini) {
					*(pic + mrow[i]*col + mcol[i]) = M;
					change++;
				    }
				    mlabel[i] = 0;
				}
			    }
			}
		    }

		    if (flagv && pass<2)
			printf("thin: frame %d reversals=%d\n",
				frameno,change);
		    if (flagv && pass==3)
			printf("thin: frame %d changes=%d\n",
				frameno,change);

		    } while (change!=0 && flags==0 && (pass==0 || pass==1));
		}
	}
}

void addmult(int row,int col,int label)
{
	int i,oldlabel;

	oldlabel = 0;
	for (i=0;i<maxmult;i++)
		if (mrow[i]==row && mcol[i]==col)
			oldlabel = mlabel[i];
	if (oldlabel) {
		for (i=0;i<maxmult;i++)
			if (mlabel[i] == oldlabel)
				mlabel[i] = label;
	}
	else {
		if (maxmult >= NMM)
			perror("M point overflow");
		mrow[maxmult] = row;
		mcol[maxmult] = col;
		mlabel[maxmult++] = label;
	}
}

int neighbor(int r,int c,int d,int row,int col)
{
	int i,j;


	i = r + rinc[d];
	j = c + cinc[d];
	if (i<0 || i>=row || j<0 || j>=col)
		return(0);
	else
		return(pic[i*col+j]&0377);
}
