void  Centipede::GetNormalVect(){
      int k,m                                                           ;
      CoordinateStruct p1,p2                                            ;
      CoordinateStruct Dv21                                             ;
      int nv21,middle,largest,smallest                                  ;
      short int *normalVectArray                                        ;

      for(k=0;k<NumberOfContours;k++){
         for(m=0;m<ContourDescriptor[k].ContourLength;m++){

         if(m>0)
           p1 = ContourDescriptor[k].ContourList[m-1].location          ;
         else
           p1 = ContourDescriptor[k].ContourList[m+1].location          ;

         p2 = ContourDescriptor[k].ContourList[m].location              ;

         if(m>0){
           Dv21 = p2 - p1                                               ;
           nv21  = NormalVectorLookUpTable[Dv21.x+1][Dv21.y+1]          ;
         }
         else{
           Dv21 = p1 - p2                                               ;
           nv21  = NormalVectorLookUpTable[Dv21.x+1][Dv21.y+1]          ;
         }
         ContourDescriptor[k].ContourList[m].normalVect = nv21          ;
        }
      }

      /* Smoothing out the normal vectors               */
      normalVectArray = new short int [MaximumContourLength] ;

      for(k=0;k<NumberOfContours;k++){
         for(m=0;m<ContourDescriptor[k].ContourLength;m++){
            middle = ContourDescriptor[k].ContourList[m].normalVect ;
            if(m>0)
              smallest = ContourDescriptor[k].ContourList[m-1].normalVect ;
            else
              smallest = ContourDescriptor[k].ContourList[m].normalVect ;
            if(m<ContourDescriptor[k].ContourLength-1)
              largest = ContourDescriptor[k].ContourList[m+1].normalVect ;
            else
              largest = ContourDescriptor[k].ContourList[m].normalVect ;

            if( ((smallest >= middle) && (smallest <= largest)) ||
                ((smallest <= middle) && (smallest >= largest)) )
              normalVectArray[m] = smallest ;
            else
            if( ((middle >= smallest) && (middle <= largest)) ||
                ((middle <= smallest) && (middle >= largest)) )
              normalVectArray[m] = middle ;
            else
            if( ((largest >= middle) && (largest <= smallest)) ||
                ((largest <= middle) && (largest >= smallest)) )
              normalVectArray[m] = largest ;
        }
         for(m=0;m<ContourDescriptor[k].ContourLength;m++)
            ContourDescriptor[k].ContourList[m].normalVect =
                                     2 * (normalVectArray[m] / 2 );
      }
      delete [] normalVectArray;
}

/********************************************************/
/* Extracting contour descriptor                        */
/********************************************************/
void  Centipede::ExtractContourDescriptor(){
      int i,j,k,*p;

      /* Check for BlobColoring has been done                           */
      HasContourDescriptorExtracted= true;
      if (HasBlobColoringBeenDone==false){
         HasBlobColoringBeenDone= true;
         BlobColoring();
      }

      /* Memory allocation for ContourDescriptor                        */
      ContourDescriptor = new ContourDescriptorStruct[NumberOfContours] ;

      /* Bounding Box                                                   */
      for (k=0;k<NumberOfContours;k++){
          ContourDescriptor[k].BoundingBox.BoxBeginH= Row;
          ContourDescriptor[k].BoundingBox.BoxBeginV= Column;
          ContourDescriptor[k].BoundingBox.BoxWidth= -1;
          ContourDescriptor[k].BoundingBox.BoxHeight= -1;
          ContourDescriptor[k].BoundingBox.BoxCenterH= 0.0;
          ContourDescriptor[k].BoundingBox.BoxCenterV= 0.0;
          ContourDescriptor[k].ContourLength= 0;
          ContourDescriptor[k].IsActive= true;
      }

      /* Contour Length                                                 */
      for (i=0;i<Row;i++){
          p= BlobColor[i];
          for (j=0;j<Column;j++){
              k = *p++;
              if (k>0){
                 k--;
                 ContourDescriptor[k].ContourLength++;
                 if (i<ContourDescriptor[k].BoundingBox.BoxBeginV)
                    ContourDescriptor[k].BoundingBox.BoxBeginV= i;
                 if (j<ContourDescriptor[k].BoundingBox.BoxBeginH)
                    ContourDescriptor[k].BoundingBox.BoxBeginH= j;
                 if (i>ContourDescriptor[k].BoundingBox.BoxHeight)
                    ContourDescriptor[k].BoundingBox.BoxHeight= i;
                 if (j>ContourDescriptor[k].BoundingBox.BoxWidth)
                    ContourDescriptor[k].BoundingBox.BoxWidth= j;
                 ContourDescriptor[k].BoundingBox.BoxCenterH+= (float)j   ;
                 ContourDescriptor[k].BoundingBox.BoxCenterV+= (float)i   ;
            }
         }
      }

      MaximumContourLength = -1                                         ;
      for(k=0;k<NumberOfContours;k++){
       ContourDescriptor[k].BoundingBox.BoxWidth   -=
                ContourDescriptor[k].BoundingBox.BoxBeginH              ;
       ContourDescriptor[k].BoundingBox.BoxHeight  -=
                ContourDescriptor[k].BoundingBox.BoxBeginV              ;
       ContourDescriptor[k].BoundingBox.BoxCenterH /=
                (float)ContourDescriptor[k].ContourLength               ;
       ContourDescriptor[k].BoundingBox.BoxCenterV /=
                (float)ContourDescriptor[k].ContourLength               ;
       ContourDescriptor[k].ContourList = (ContourListStruct *)
                     malloc(ContourDescriptor[k].ContourLength *
                             sizeof(ContourListStruct))                 ;
         if(MaximumContourLength<ContourDescriptor[k].ContourLength)
           MaximumContourLength = ContourDescriptor[k].ContourLength    ;
      }

      /* ContourList                                                    */
      for (k=1;k<=NumberOfContours;k++){
          GetContourInfo(k) ;
      }
      for (i=0;i<Row;i++){
          p= BlobColor[i];
          for (j=0;j<Column;j++){
              *p++ -= NumberOfContours ;
          }
      }
}

void  Centipede::GetContourInfo(int contourNo){
      CoordinateStruct endPoint         ;

      endPoint = FindEndPointOfTheContour(contourNo)   ;
      if( (endPoint.x == -1) && (endPoint.y == -1)){
         ContourDescriptor[contourNo-1].IsClosedContour = true ;
         endPoint = FindFirstPointOfTheContour(contourNo) ;
      }
      else
         ContourDescriptor[contourNo-1].IsClosedContour = false ;
      FollowThePoint(endPoint,0,contourNo,0) ;
}

void Centipede::FollowThePoint(CoordinateStruct   endPoint,
                               int predictedDirection,
                               int contourNo,
                               int index)
{
     int k,l,xx,yy,m,n                  ;
     CoordinateStruct predictedPoint    ;
     int direction                      ;

     ContourDescriptor[contourNo-1].ContourList[index].location = endPoint ;

     BlobColor[endPoint.x][endPoint.y] += NumberOfContours ;

     /************************************************************************/
     /*                                                                      */
     /* Count the number of contourNo's in the neighbor of endPoint          */
     /*                                                                      */
     /************************************************************************/
     n=0;
     for(k=-1;k<2;k++)
        for(l=-1;l<2;l++)
           if(ValidPixel(endPoint.x+k,endPoint.y+l)&&((k!=0)||(l!=0)))
             if(BlobColor[endPoint.x+k][endPoint.y+l]==contourNo){
               ++n;
               if(n==1){xx=k;yy=l;}
             }

     /************************************************************************/
     /*                                                                      */
     /* These are the cases :                                                */
     /* n = 0 : No other edge in the neighbor (the other end point           */
     /*         of the contour)                                              */
     /* n = 1 : One edge to visit hence one direction to follow              */
     /* n > 1 : Many directions to follow ; choose the one causing minimum   */
     /*         rotation in the path                                         */
     /*                                                                      */
     /************************************************************************/
     if(n>0)
     if(n==1){ /* no alternative to visit */
        predictedPoint.x = endPoint.x + xx              ;
        predictedPoint.y = endPoint.y + yy              ;
        predictedDirection = CrossConversion[xx+1][yy+1]        ;
        FollowThePoint(predictedPoint,predictedDirection,contourNo,index+1)  ;
     }else{
       if(n>1){ /* in this case choose the best direction from many    */
         predictedPoint = endPoint + Displacement[predictedDirection]        ;
         if(ValidPixel(predictedPoint.x,predictedPoint.y))
           if(BlobColor[predictedPoint.x][predictedPoint.y]==contourNo){
             /* No rotation in the path                                */
         FollowThePoint(predictedPoint,predictedDirection,contourNo,index+1)  ;
           }
           else{ /* No edge at the most desired point                  */
             m=1;
             do{ /* First predict then test the direction              */
             direction = (predictedDirection + m + 8)%8       ;
             predictedPoint = endPoint + Displacement[direction]   ;
             if(ValidPixel(predictedPoint.x,predictedPoint.y))
               if(BlobColor[predictedPoint.x][predictedPoint.y]==contourNo){
                 FollowThePoint(predictedPoint,direction,contourNo,index+1)  ;
                 break;
               }
             if(m<0) m=-m+1     ;
             else m = -m        ;
             }while(m!=4);
           } /* else */
       }
     }
}

CoordinateStruct Centipede::FindEndPointOfTheContour(int contourNo){
     int i,j,k,l,n                              ;
     CoordinateStruct   endPoint={-1,-1}        ;

     for(i=0;i<Row;i++)
        for(j=0;j<Column;j++){ // 1
           if(BlobColor[i][j]== contourNo){ // 2
             n=0;
             for(k=-1;k<2;k++)
                for(l=-1;l<2;l++)
                   if(ValidPixel(i+k,j+l)&&((k!=0)||(l!=0)))
                     if(BlobColor[i+k][j+l]==contourNo)
                       n++;

               if(n==1){ // 3
                 endPoint.x = i         ;
                 endPoint.y = j         ;
                 return endPoint        ;
               } // 3
           } // 2
        } // 1
     return endPoint        ;
}

CoordinateStruct Centipede::FindFirstPointOfTheContour(int contourNo){
     int i,j                                    ;
     CoordinateStruct   endPoint={-1,-1}        ;

     for(i=0;i<Row;i++)
        for(j=0;j<Column;j++)
           if(BlobColor[i][j]== contourNo){
             endPoint.x = i         ;
             endPoint.y = j         ;
             return endPoint        ;
           }
      return endPoint        ;
}

void  Centipede::BlobColoring(){
      int i,j                   ;
      CoordinateStruct endPoint ;

      BlobColor = new int *[Row] ;
      BlobColor[0] = new int [Row*Column] ;
      int *p=BlobColor[0]+Column;
      for (i=1;i<Row;i++,p+=Column)
          BlobColor[i] = p ;

      HasBlobColoringBeenDone = true    ;

      for (i=0;i<Row;i++)
          for (j=0;j<Column;j++)
              if (edge[i][j]){
                 BlobColor[i][j] = -1      ;
                 NumberOfEdges++           ;
              }else
                 BlobColor[i][j] = 0      ;

      while(NumberOfEdges){
        endPoint = GetNextEndPoint()    ;
        if((endPoint.x==-1)&&(endPoint.y==-1)) break;
        NumberOfContours++;
        FollowEndPoint(endPoint,0) ;
      }

       do{
        endPoint = GetFirstPoint()    ;
        if((endPoint.x==-1)&&(endPoint.y==-1)) break;
        NumberOfContours++;
        FollowEndPoint(endPoint,1) ;
      }while(1);
}

void Centipede::FollowEndPoint(CoordinateStruct endPoint,
                             int        predictedDirection){
     int k,l,m,n,xx,yy                  ;
     int direction                      ;
     CoordinateStruct predictedPoint    ;

     BlobColor[endPoint.x][endPoint.y] = NumberOfContours               ;

     /************************************************************************/
     /*                                                                      */
     /* Count the number of 1's in the 8-neighbor of the point endPoint      */
     /*                                                                      */
     /************************************************************************/
     n=0;
     for(k=-1;k<2;k++)
        for(l=-1;l<2;l++)
           if(ValidPixel(endPoint.x+k,endPoint.y+l)&&((k!=0)||(l!=0)))
             if(BlobColor[endPoint.x+k][endPoint.y+l]==-1){
               ++n;
               if(n==1){xx=k;yy=l;}
             }

     /************************************************************************/
     /*                                                                      */
     /* These are the cases :                                                */
     /* n = 0 : No other edge in the neighbor (the other end point           */
     /*         of the contour)                                              */
     /* n = 1 : One edge to visit hence one direction to follow              */
     /* n > 1 : Many directions to follow ; choose the one causing minimum   */
     /*         rotation in the path                                         */
     /*                                                                      */
     /************************************************************************/
     if(n>0)
     if(n==1){ /* no alternative to visit */
        predictedPoint.x = endPoint.x + xx              ;
        predictedPoint.y = endPoint.y + yy              ;
        predictedDirection = CrossConversion[xx+1][yy+1]        ;
        FollowEndPoint(predictedPoint,predictedDirection)  ;
     }else{
       if(n>1){ /* in this case choose the best direction from many    */
         predictedPoint = endPoint + Displacement[predictedDirection]        ;
         if(ValidPixel(predictedPoint.x,predictedPoint.y))
           if(BlobColor[predictedPoint.x][predictedPoint.y]==-1){
             /* No rotation in the path                                */
             FollowEndPoint(predictedPoint,predictedDirection)  ;
           }
           else{ /* No edge at the most desired point                  */
             m=1;
             do{ /* First predict then test the direction              */
             direction = (predictedDirection + m + 8)%8       ;
             predictedPoint = endPoint + Displacement[direction]   ;
             if(ValidPixel(predictedPoint.x,predictedPoint.y))
               if(BlobColor[predictedPoint.x][predictedPoint.y]==-1){
                 FollowEndPoint(predictedPoint,direction)  ;
                 break;
               }
             if(m<0) m=-m+1     ;
             else m = -m        ;
             }while(m!=4);
           } /* else */
       }
     }
}

CoordinateStruct Centipede::GetNextEndPoint(){
     int i,j,k,l,n                              ;
     CoordinateStruct   endPoint={-1,-1}        ;

     for(i=0;i<Row;i++)
        for(j=0;j<Column;j++){ // 1
           if(BlobColor[i][j]==-1){ // 2

             n=0;
             for(k=-1;k<2;k++)
                for(l=-1;l<2;l++)
                   if(ValidPixel(i+k,j+l)&&((k!=0)||(l!=0)))
                     if(BlobColor[i+k][j+l]==-1)
                       n++;

             if(n==0) /* isolated edge */
               BlobColor[i][j]=0        ;
             else
               if(n==1){ /* real end point */
                 endPoint.x = i         ;
                 endPoint.y = j         ;
                 return endPoint        ;
               }
           }
        }
     return endPoint        ;
}

CoordinateStruct Centipede::GetFirstPoint(){
     int i,j                                    ;
     CoordinateStruct firstPoint={-1,-1}        ;

     for(i=0;i<Row;i++)
        for(j=0;j<Column;j++)
           if(BlobColor[i][j]==-1){
              firstPoint.x = i                  ;
              firstPoint.y = j                  ;
              return firstPoint                 ;
           }
     return firstPoint                          ;
}
