//---------------------------------------------------------------------------
#include <vcl.h>
#include <clipbrd.hpp>
#include <jpeg.hpp>
#pragma hdrstop

#include <math>
#include <float>
#include <process>
#include "Unit1.h"
#ifndef Unit2H
#include "Unit2.h"
#endif

#include "centipede.h"
#include "sor.h"
#include "Edge.cpp"
#include "Image.cpp"

Centipede theCentipede          ;
SOR       ReconstructedSurface  ;

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Image1Click(TObject *Sender)
{
  if(OpenPictureDialog1->Execute()){
      theCentipede.freeAll() ;
      theCentipede.init() ;
      theCentipede.AssignName(OpenPictureDialog1->FileName.c_str())    ;
      Image2->AutoSize = true ;
      Image2->Stretch = false ;
      Image2->Picture->LoadFromFile(OpenPictureDialog1->FileName)       ;
      Image2->AutoSize = false ;
      Image2->Stretch = true ;
      theCentipede.LoadFromTImage(Image2)                              ;
      Form1->Caption = "  " + OpenPictureDialog1->FileName +
                       "  -  Centipede Codec";
      menuItemShowReconstructedImage->Enabled= false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::onActionCommand(TObject *Sender)
{
   int multiplyScale ;
   int divideScale ;

   if (Sender==View150){
      multiplyScale= 15 ;
      divideScale= 10 ;
   }
   else
   if (Sender==View200){
      multiplyScale= 2 ;
      divideScale= 1 ;
   }
   else
   if (Sender==View250){
      multiplyScale= 25 ;
      divideScale= 10 ;
   }
   else
   if (Sender==View300){
      multiplyScale= 3 ;
      divideScale= 1 ;
   }
   else
   if (Sender==View400){
      multiplyScale= 4 ;
      divideScale= 1 ;
   }
   else
   if (Sender==View400){
      multiplyScale= 4 ;
      divideScale= 1 ;
   }
   else
   if (Sender==View80){
      multiplyScale= 8 ;
      divideScale= 10 ;
   }
   else
   if (Sender==View70){
      multiplyScale= 7 ;
      divideScale= 10 ;
   }
   else
   if (Sender==View50){
      multiplyScale= 5 ;
      divideScale= 10 ;
   }
   else
   if (Sender==View25){
      multiplyScale= 1 ;
      divideScale= 4 ;
   }
   else
   if (Sender==View10){
      multiplyScale= 1 ;
      divideScale= 10 ;
   }
   else
   if (Sender==ViewNormal){
      multiplyScale= 1 ;
      divideScale= 1 ;
   }
   Image2->Width  = (multiplyScale * theCentipede.Width) / divideScale     ;
   Image2->Height = (multiplyScale * theCentipede.Height) / divideScale    ;
   Image3->Left   = (multiplyScale * theCentipede.Width) / divideScale + 20;
   Image3->Width  = (multiplyScale * theCentipede.Width) / divideScale     ;
   Image3->Height = (multiplyScale * theCentipede.Height) / divideScale    ;
   Image2->Refresh() ;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Copy1Click(TObject *Sender)
{
    Clipboard()->Assign(Image2->Picture);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Paste1Click(TObject *Sender)
{
    if(Clipboard()->HasFormat(CF_PICTURE)){
       Image2->Picture->Assign(Clipboard())             ;
       theCentipede.LoadFromTImage(Image2)             ;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Invert1Click(TObject *Sender)
{
  theCentipede.Invert()                                ;
  theCentipede.SaveToTImage(Image2)                    ;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Converttograyscale1Click(TObject *Sender)
{
  theCentipede.SaveToTImage(Image2)                    ;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DetectContours1Click(TObject *Sender)
{
    Image2->AutoSize = true ;
    Image2->Stretch = false ;
    Image2->Picture->LoadFromFile(OpenPictureDialog1->FileName)       ;
    Image2->AutoSize = false ;
    Image2->Stretch = true ;
    theCentipede.LoadFromTImage(Image2)                              ;

    theCentipede.SetLambda(1.0)                ;
    theCentipede.SetTau(0.1)                   ;
    theCentipede.SetGFilterLength(5)           ;
    theCentipede.SetThresholds(70,80)          ;
    theCentipede.GetEdges()                    ;
    theCentipede.SaveEdgesToTImage(Image2)     ;
    theCentipede.RFilter()                     ;
    Form2->Visible=true ;
    menuItemShowEdges->Checked=true ;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TraceContours1Click(TObject *Sender)
{
       theCentipede.ExtractContourDescriptor();
       theCentipede.SaveContoursToTImage(Image2,Image3);
       menuItemShowContours->Checked=true ;       
}
//---------------------------------------------------------------------------
void __fastcall TForm1::menuItemShowGrayLevelClick(TObject *Sender)
{
     theCentipede.SaveToTImage(Image2)      ;
     menuItemShowGrayLevel->Checked= true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::menuItemShowEdgesClick(TObject *Sender)
{
     theCentipede.SaveEdgesToTImage(Image2)      ;
     menuItemShowEdges->Checked= true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::menuItemShowContoursClick(TObject *Sender)
{
     theCentipede.SaveContoursToTImage(Image2,Image3)      ;
     menuItemShowContours->Checked= true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::menuItemShowBoundingBoxClick(TObject *Sender)
{
     theCentipede.DrawBoundingBox(Image2) ;
     menuItemShowBoundingBox->Checked= true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::menuItemShowDescriptorClick(TObject *Sender)
{
     theCentipede.SaveDescriptorToTImage(Image2)   ;
     menuItemShowDescriptor->Checked= true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ObtainCentipede1Click(TObject *Sender)
{
     theCentipede.GetNormalVect();
     theCentipede.LambdaForData= 0.1 ;
     theCentipede.ExtractOptimalCentipedeModelParameters();
//          Centipede.SaveModelToTImage(Image2,Image3,true)   ;
     ReconstructedSurface.Width  = ReconstructedSurface.Column =
                                    theCentipede.Width;
      ReconstructedSurface.Height = ReconstructedSurface.Row =
                                    theCentipede.Height ;
      ReconstructedSurface.AllocateMemoryForModelMatrices();
      theCentipede.SaveModelToMatrices(ReconstructedSurface.beta,
                                    ReconstructedSurface.depth,true);
      ReconstructedSurface.SaveDepthAndBetaToTImage(Image2,Image3);
      Reconstruct1->Enabled= true;
      menuItemShowCentipedeModel->Checked= true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Reconstruct1Click(TObject *Sender)
{
      ReconstructedSurface.SetParameters(64.0,0.5,1.1,0.0005,true)     ;
      ReconstructedSurface.ReconstructTheSurface() ;
      ReconstructedSurface.SaveToTImage(Image2) ;
      menuItemShowReconstructedImage->Enabled= true;
      menuItemShowReconstructedImage->Checked= true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::menuItemShowReconstructedImageClick(TObject *Sender)
{
      ReconstructedSurface.SaveToTImage(Image2) ;
      menuItemShowReconstructedImage->Checked= true;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::menuItemShowCentipedeModelClick(TObject *Sender)
{
       ReconstructedSurface.SaveDepthAndBetaToTImage(Image2,Image3)      ;
       menuItemShowCentipedeModel->Checked= true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CompressionParameters1Click(TObject *Sender)
{
  Form2->Visible = true ;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CompresstoFile1Click(TObject *Sender)
{
     if (OpenDialog1->Execute()){
        theCentipede.CompressCentipede(OpenDialog1->FileName.c_str()) ;
     }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PBrushClick(TObject *Sender)
{
     spawnl(P_NOWAIT,"c:\\WINDOWS\\System32\\mspaint.exe","ONE",NULL) ;
     Clipboard()->Assign(Image2->Picture);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CodedImagecentipede1Click(TObject *Sender)
{
     if(OpenDialog1->Execute()){
       Form1->Caption = "  " + OpenDialog1->FileName +
                       "  -  Centipede Codec"                     ;
       theCentipede.DecodeCentipede(OpenDialog1->FileName.c_str())   ;
       theCentipede.SaveDescriptorToTImage(Image2)                   ;
       DecompressCentipede1->Enabled = true                       ;
       Reconstruct1->Enabled = true                               ;
       ReconstructedSurface.Width  = ReconstructedSurface.Column =
                                    theCentipede.Width ;
       ReconstructedSurface.Height = ReconstructedSurface.Row =
                                    theCentipede.Height ;
       ReconstructedSurface.AllocateMemoryForModelMatrices()     ;
       theCentipede.SaveModelToMatrices(ReconstructedSurface.beta,
                                    ReconstructedSurface.depth,true) ;
       ReconstructedSurface.SaveDepthAndBetaToTImage(Image2,Image3)      ;
     }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Best1Click(TObject *Sender)
{
  Poor1->Checked = false ;
  Fair1->Checked = false ;
  Best1->Checked = true ;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Fair1Click(TObject *Sender)
{
  Best1->Checked = false ;
  Poor1->Checked = false ;
  Fair1->Checked = true ;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Poor1Click(TObject *Sender)
{
  Best1->Checked = false ;
  Fair1->Checked = false ;
  Poor1->Checked = true ;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Save1Click(TObject *Sender)
{
  if (SaveDialog1->Execute()){
     Image2->Picture->SaveToFile(SaveDialog1->FileName) ;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Helpcontent1Click(TObject *Sender)
{
   Application->HelpContext(10) ;
}
//---------------------------------------------------------------------------

